C     PROGRAM BMCYCL(INPUT,OUTPUT,PLOT,TAPE5=INPUT,TAPE6=OUTPUT)
C
      COMMON /APLOT/ PY,WYILD,DYILD
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION WL(20),       YO(20),RLA(10),FLA(10)
      OPEN (UNIT=5,FILE='BMDATA') 
      OPEN (UNIT=6,FILE='BMRESL')
c     CALL PLOTS
c     CALL PLOT(10.0,5.0,-3)
c     CALL AXIS(-10.0,0.0,38HSHORTENING       AND  DEFLECTION  W/WY,-38,
c    1     14.0,0.0,-10.0,1.0,0)
c     CALL AXIS(0.0,-5.0,47H                              AXIAL FORCE  P
c    1/PY,47,10.0,90.0,-1.0,0.2,-1)
C
   10 CALL INPUT(IND,AL,PP,PDELT,NP,EM0S,QS,NEL,WL,YLMT,NTH,ALPH,NRT,RLA
     1          ,FLA)
      CTRL=1
      IF(IND.GE.3) CTRL=2
      IF(IND.EQ.3) IND=1
      IF(IND.EQ.4) IND=2
C
      CALL DATAGE(IND,AL,QS,EM0S,NEL,PCR,W0MQ,RO,NTH)
      CALL INTIAL(ALPH,NRT,RLA,FLA,RO,NTH,NEL)
C
      CALL PRBUCK(IND,AL,PP,PDELT,NP,EM0S,QS,NEL,WL,PCR,W0MQ,   P,YO,
     1               NTH)
C
      CALL PSBUCK(YO,P,NEL,EM0S,QS,WL,IND,AL,YLMT,NTH)
C
      IF(CTRL.EQ.2) GO TO 50
      CALL UNLOAD(IND,PDELT,EM0S,QS,NEL,WL,NTH,YO)
C
      CALL TENSPL(IND,EM0S,QS,NEL,WL,NTH)
C
   50 DO 20 I=1,KP
      YY(I)=YY(I)/PY
      XW(I)=-XW(I)/WYILD
   20 XS(I)=XS(I)/DYILD
      YY(KP+1)=0.0
      YY(KP+2)=0.2
      XW(KP+1)=0.0
      XW(KP+2)=1.0
      XS(KP+1)=0.0
      XS(KP+2)=1.0
      PRINT *,'  KP=',KP
      PRINT *,YY(I),  XW(I),  XS(I)
      WRITE(6,500) (YY(I1),I1=1,100)
      WRITE(6,500) (XW(I1),I1=1,100)
      WRITE(6,500) (XS(I1),I1=1,100)
c     CALL DSHLINE(XW,YY,KP,0.2,0.08,1)
c     CALL DSHLINE(XS,YY,KP,0.0,0.0,0)
      GO TO 10
  500 FORMAT(1H ,/, 5(1X,10E12.4,/),/,5(1X,10E12.4,/))
      END
      SUBROUTINE INPUT(IND,AL,PP,PDELT,NP,EM0S,QS,NEL,WL,YLMT,NTH,ALPH,
     1      NRT,RLA,FLA)
      COMMON /MAT/ E,SY,D,T,DA
      DIMENSION  WL(20),TITLE(20),RLA(10),FLA(10)
C  IND=1... ASYMMETRIC COLUMN ANALYSIS, 1-CYCLE OF LOADING
C  IND=2... SYMMETRIC  COLUMN ANALYSIS, 1-CYCLE OF LOADING
C   IND=3... ASYMMETRIC COLUMN ANALYSIS, BUCKLING BEHAVIOR
C   IND=4... SYMMETRIC COLUMN ANALYSIS, BUCKLING BEHAVIOR
      PAI=4.0*ATAN(1.0)
      READ(5,100,END=999) (TITLE(I),I=1,18)
      WRITE(6,400) (TITLE(I),I=1,18)
      READ(5,*) IND,AL,D,T,SY,E,NEL,NTH,SPRG
      WRITE(6,405) IND,AL,D,T,SY,E,NEL,NTH
      WRITE(6,401) SPRG
      AL=12.0*AL
      READ(5,*)    PP,PDELT,NP,EM0S,QS,YLMT
      WRITE(6,410) PP,PDELT,NP,EM0S,QS,YLMT
      PL=AL
      IF(IND.EQ.2.OR.IND.EQ.4) PL=2.0*AL
C  NCW=1... INITIAL DEFLECTION IS SINUSOIDAL
C  NCW=2... WL(I)=WL(I)*PL
      READ(5,*) NCW,(WL(I),I=1,NEL+1)
      IF(NCW.NE.1) GO TO 10
      A=WL(1)*PL
      DO 12 I=1,NEL+1
      WL(I)=A*SIN(PAI*FLOAT(I-1)/FLOAT(NEL))
   12 IF(IND.EQ.2.OR.IND.EQ.4) WL(I)=A*SIN(0.5*PAI*FLOAT(I-1)/FLOAT(NEL)
     1         )
   10 IF(NCW.NE.2) GO TO 25
      DO 15 I=1,NEL+1
   15 WL(I)=WL(I)*PL
   25 WRITE(6,520)  NCW
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,521) (WL(I),I=1,NEL+1,KW)
      READ(5,*) ALPH,NRT,(RLA(I),FLA(I),I=1,NRT)
      WRITE(6,220) ALPH,(RLA(I),I=1,NRT)
      WRITE(6,221)  (FLA(I),I=1,NRT)
      RETURN
  999 CALL PLOT(0.0,0.0,999)
      STOP
  100 FORMAT(18A4)
  220 FORMAT(/,5X,'ALPH=',F5.2,/,5X,'RLA(I)=',10E12.3)
  221 FORMAT(5X,'FLA(I)=',10E12.3)
  400 FORMAT(1H1,/,/,18A4)
  401 FORMAT(1H ,'   SPRG=',E12.4)
  405 FORMAT(/,'    IND=',I2,4X,'AL=',E12.4,'   D=',E12.4,'   T=',E12.4,
     1      '   SY=',E12.4,'   E=',E12.4,'   NEL=',I3,'   NTH=',I3)
  410 FORMAT(1H ,/,6X,'P=',E12.4,'  PDELT=',E12.4,'  NP=',I3,'  EM0S=',
     1   E12.4,'  QS=',E12.4,'   Y(LIMIT)=',E12.4)
  520 FORMAT(1H ,/,5X,'INITIAL OUT-OF-STRAIGHTNESS      NCW=',I2)
  521 FORMAT(1H ,5X,'WL(I)=',10E11.3)
      END
      SUBROUTINE DATAGE(IND,AL,QS,EM0S,NEL,PCR,W0MQ,RO,NTH)
      COMMON /MAT/ E,SY,D,T,DA
      COMMON /COORD/ X0(150),Y0(150)
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /APLOT/ PZ,WYILD,DYILD
C  DATA GENERATION FOR THE MEMBER FROM THE INPUTS
      PAI=4.0*ATAN(1.0)
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))
      DA=SA/FLOAT(NTH)
      PHIY=ATAN(2.0*SY/D/E)
      EMY=E*SI*PHIY
      EM0S=EM0S*EMY
      PY=SA*SY
      PZ=PY
      PL=AL
      IF(IND.EQ.2)  PL=2.0*AL
      PAIL=PL/PAI
      PCR=E*SI/(PAIL*PAIL)
      PES=PCR/PY
      SRT=PL/SQRT(SI/SA)
      QS=QS*EMY*4.0/PL
      W0Q=QS*PL**3/(48.0*E*SI)
      W0M=EM0S*PL*PL/(8.0*E*SI)
      W0MQ=W0Q+W0M
      WYILD=PHIY*PAIL*PAIL
      DYILD=PL*SY/E
      DO 10 I=1,NEL+1
      DL=AL/FLOAT(NEL)
   10 X(I)=DL*FLOAT(I-1)
      WRITE(6,420) SI,SA,PHIY,PES,PY,EMY
      WRITE(6,430) W0MQ,SRT,WYILD,DYILD
      RO=D/2.0
      RT=RO-T
C   COORDINATES OF CENTROID OF EACH ELEMENT
      DTHTA5=2.0*PAI/FLOAT(NTH)/2.0
      EPSY=2.0*SIN(DTHTA5)/3.0
      EPS=EPSY*(RO**3-RT**3)/DA
      DO 20 I=1,NTH
      THTA=2.0*DTHTA5*FLOAT(I-1)+DTHTA5
      X0(I)=EPS*COS(THTA)
   20 Y0(I)=EPS*SIN(THTA)
      WRITE(6,110)
      WRITE(6,900) (X0(I),Y0(I),I=1,NTH)
      RETURN
  110 FORMAT( /, 1X,'COORDINATES',/,2X,5(5X,'X0',11X,'Y0',6X))
  900 FORMAT(   15(10(2X,E11.4),/))
  420 FORMAT(1H ,/,6X,'SI=',E12.4,'  SA=',E12.4,'  PHIY=',E12.4,'  PES='
     1     ,E12.4,'  PY=',E12.4,'  EMY=',E12.4)
  430 FORMAT(/,6X,  'W0QM=',E12.4,'    SRT=',E12.4,'    WYILD=',E12.4,
     1    '  DYILD=',E12.4)
      END
      SUBROUTINE INTIAL(ALPH,NRT,RLA,FLA,RO,NTH,NEL)
C  CALCULATION OF LONGITUDINAL RESIDUAL STRESS IN EACH ELEMENT
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      DIMENSION RLA(10),FLA(10),RLB(10),A(150)
      PAI=4.0*ATAN(1.0)
      DTH=2.0*PAI/FLOAT(NTH)
      AT=0.0
      DO 50 K=1,NRT
   50 RLB(K)=RLA(K)*RO
      DO 55 I=1,NTH/2
      SL=DTH*(FLOAT(I)-0.5)*RO
      DO 60 J=1,NRT
      IF(RLB(J).LE.SL.AND.RLB(J+1).GT.SL) GO TO 65
   60 CONTINUE
   65 RAT=(SL-RLB(J))/(RLB(J+1)-RLB(J))
      RSTA(1,I)=FLA(J)+(FLA(J+1)-FLA(J))*RAT
      RSTA(1,NTH-I+1)=RSTA(1,I)
      AT=AT+RSTA(1,I)
   55 CONTINUE
C  ADJUSTMENT IN ORDER TO KEEP EQUILIBLIUM AT A SECTION
C   A(I)= RESIDUAL STRESSES ACCORDINT TO INPUT
C   RSTA   = RESIDUAL STRESSES AFTER ADJUSTING FOR EQUILIBRIUM
      AVE=AT/FLOAT(NTH/2)
      ALPH=PAI*ALPH/180.
      NALPH=IFIX(ALPH+0.001)/DTH
      IF(NALPH.GT.1) GO TO 75
      DO 85 I=1,NTH
   85 A(I)=RSTA(1,I)
      GO TO 80
C  ROTATE WELD SEAM
   75 DO 70 I=1,NTH-NALPH
   70 A(NALPH+I)=RSTA(1,I)
      DO 71 I=NTH-NALPH+1,NTH
   71 A(I-NTH+NALPH)=RSTA(1,I)
   80 DO 72 I=1,NTH
   72 RSTA(1,I)=A(I)-AVE
C
      WRITE(6,900) (RSTA(1,I),I=1,NTH)
      WRITE(6,901) (A(I),I=1,NTH)
      DO 110 J=2,NEL+1
      DO 110 I=1,NTH
  110 RSTA(J,I)=RSTA(1,I)
      WRITE(6,500)
C   INITIAL VALUES OF STRAIN FOR EACH ELEMENT
      DO 100 J=1,NEL+1
      DO 100 I=1,NTH
  100 ES(J,I)=0.0
      RETURN
  500 FORMAT(1H1)
  900 FORMAT( /, 1X,'RESIDUAL STRESS',/,'  RSTA(I)',15(/,10(3X,F10.4)))
  901 FORMAT( /,'  A(I)   ',15(/,10(3X,F10.4)))
      END
      SUBROUTINE PRBUCK(IND,AL,PP,PDELT,NP,EM0,Q,NEL,WL,PCR,W0MQ,
     1         P,YO,NTH)
C  NEWMARK'S METHOD FOR PREBUCKLING BRANCH
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      COMMON /SPACE/ S0(10,99),ES0(10,99)
      DIMENSION WL(20),YA(20),YO(20),XAO(10,3),FAO(10,3)
      PAI=4.0*ATAN(1.0)
      KW=1
      IF(NEL.GT.10) KW=2
      KP=0
      DO 5 J=1,NEL+1
      DO  5 I=1,3
      FA(J,I)=0.0
    5 XA(J,I)=0.0
C
      DO 100 IP=1,NP
      P=PP+PDELT*FLOAT(IP-1)
      WRITE(6,560) -P
      PW=P
      IF(PW.GT.0.95*PCR) PW=0.95*PCR
      WX=WL(NEL/2+1)+W0MQ
      IF(IND.EQ.2) WX=WL(NEL+1)+W0MQ
      W1=WX/(1.0-PW/PCR)
      IF(W1.LT.1.0E-10) W1=0.1
      AROW=W1-WX
      DO 40 I=1,NEL+1
      YA(I)=AROW *SIN(PAI*X(I)/AL)
   40 IF(IND.EQ.2) YA(I)=AROW*SIN(PAI*X(I)/AL/2.0)
      WRITE(6,502) (X(I),I=1,NEL+1,KW)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
C  ITERATIVE PROCESS STARTS
      DO 3 J=1,NEL+1
      DO 3 I=1,3
      XAO(J,I)=XA(J,I)
    3 FAO(J,I)=FA(J,I)
      N=0
   90 N=N+1
      DO 7 J=1,NEL+1
      DO 7 I=1,3
      XA(J,I)=XAO(J,I)
    7 FA(J,I)=FAO(J,I)
      IF(N.LE.25) GO TO 80
      WRITE(6,900)
      GO TO 100
C
   80 CALL CYCLE(YA,-P,EM0,Q,WL,NEL,IND,NTH,IFAC)
      IF(IFAC.NE.1) GO TO 50
      P= P-PDELT
      DO 4 J=1,NEL+1
      DO 4 I=1,3
      XA(J,I)=XAO(J,I)
    4 FA(J,I)=FAO(J,I)
      GO TO 850
C
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
   55 IF(ABS(YB(I)).GT.YAA) YAA=ABS(YB(I))
      IF(YAA.LT.0.001) GO TO 314
      EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.01*YAA) GO TO 350
  314 WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      DO 20 I=1,NEL+1
      DO 20 L=1,NTH
      ES(I,L)=ES0(I,L)
   20 RSTA(I,L)=S0(I,L)
      KP=KP+1
      YY(KP)=-P
      IF(IND.NE.1) GO TO 10
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
   10 IF(IND.NE.2) GO TO 100
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*YAA) GO TO 315
      WRITE(6,910)
      GO TO 850
  315 DO 320 I=1,NEL+1
      YO(I)=YA(I)
  320 YA(I)=YB(I)
      GO TO 90
  100 CONTINUE
  850 RETURN
  502 FORMAT(1H ,2X,'X(I)',3X,10E12.4)
  560 FORMAT(1H ,/,/,/,/,2X,'P =',E13.4)
  561 FORMAT(1H ,/,5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(1H ,/,'==== CONVERGENCE')
  900 FORMAT(1H ,'***  TOO MANY ITERATIONS IN NEWMARK')
  910 FORMAT(1H ,/,'*** EROR GREATER THAN 50*YAA IN NEWMARK')
      END
      SUBROUTINE PSBUCK(YO,P,NEL,EM0,Q,WL,IND,AL,YLMT,NTH)
C  NEWMARK'S METHOD FOR POST-BUCKLING BRANCH
C  THIS SUBROUTINE IS PROGRAMMED ONLY FOR SYMMETRIC BEAM-COLUMN
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      COMMON /DATA/ EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      COMMON /SPACE/ S0(10,99),ES0(10,99)
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      DIMENSION YO(20),WL(20),YA(20),XAO(10,3),FAO(10,3)
      EMR=0.0
      DY=0.0
      PO=0.0
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,500)
      DO 10 I=1,NEL+1
   10 YA(I)=YO(I)
      J=0
  100 J=J+1
      DO 3 K=1,NEL+1
      DO 3 I=1,3
      XAO(K,I)=XA(K,I)
    3 FAO(K,I)=FA(K,I)
      IF(J.LE.15) GO TO 104
      WRITE(6,910)
      GO TO 850
  104 M=0
      PUP=2.0*P
      PLO=0.0
  105 M=M+1
      IF(M.LE.25) GO TO 110
      WRITE(6,905)
      DO 6 K=1,NEL+1
      DO 6 I=1,3
      XA(K,I)=XAO(K,I)
    6 FA(K,I)=FAO(K,I)
      GO TO 850
  110 N=0
   90 N=N+1
      DO 7 K=1,NEL+1
      DO 7 I=1,3
      XA(K,I)=XAO(K,I)
    7 FA(K,I)=FAO(K,I)
      IF(N.LE.15) GO TO 80
      WRITE(6,900)
      GO TO 850
   80 CONTINUE
      WRITE(6,560) -P
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
C
      CALL CYCLE(YA,-P,EM0,Q,WL,NEL,IND,NTH,IFAC)
C
      IF(IFAC.NE.1) GO TO 50
      WRITE(6,501)
      ID=0
      DO 60 I=1,NEL+1
      AYB=ABS(YA(I)-YB(I))
   60 IF(ABS(PO-P).GT.0.1.OR.AYB.GT.0.15*ABS(YA(I)))ID=10
      IF(ID.LE.0) GO TO 314
      IF(ABS(PO-P).GT.0.001) GO TO 70
      DO 4 K=1,NEL+1
      DO 4 I=1,3
      XA(K,I)=XAO(K,I)
    4 FA(K,I)=FAO(K,I)
      GO TO 850
   70 PO= P
      PS=P/PY
      EMPC=1.273*(1.0-1.18*PS*PS)
      IF(PS.GT.0.65) EMPC=1.82*(1.0-PS)
      PPL=(EMPC*EMY-EM0 +EMR-Q /2.0*X(NEL+1))/(YA(NEL+1)+WL(NEL+1))
      IF(PPL.LT.PO) P=(PPL+PO)/2.0
      IF(ABS(PO-P).LT.0.01) P=PO-0.5
      PUP=PO
      PRINT*,'PUP=',PUP,'PLO=',PPL
      GO TO 105
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
      IF(ABS(YB(I)).LT.YAA)  GO TO 55
      YAA=ABS(YB(I))
      IMAX=I
   55 CONTINUE
      IF(YAA.LT.0.01 *YA(NEL+1).OR.YAA.LT.0.01 ) GO TO 314
      EROR=0.05*YAA
      IC=0
      DO 310 I=1,NEL+1
  310 IF(ABS(YB(I)-YA(I)).GT.EROR) IC=I
      IF(IC.NE.0) GO TO 311
  314 WRITE(6,560) -P
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      DO 20 I=1,NEL+1
      YO(I)=YB(I)
      DO 20 L=1,NTH
      ES(I,L)=ES0(I,L)
   20 RSTA(I,L)=S0(I,L)
      WRITE(6,600)
      DY=DY+FLOAT(J)/FLOAT(IND)
      IF(DY.GT.1.5) DY=1.5
      IF(YB(NEL+1)+DY.GT.YLMT) DY=YLMT-YB(NEL+1)
      KP=KP+1
      YY(KP)=-P
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      IF(DY.LT.0.3) GO TO 850
      DO 320 I=1,NEL+1
      IF(YB(I).GT.YLMT) GO TO 850
  320 YA(I)=YB(I)+DY*X(I)/AL
      GO TO 100
  311 IF(IC.EQ.NEL+1) GO TO 350
      DO 312 I=1,NEL+1
  312 YA(I)=YB(I)
      PUP=PUP+0.5
      PLO=PLO-0.5
      GO TO 105
  350 YMAX=YB(IMAX)
      IF(N.NE.1) GO TO 351
      P1=(BM(IMAX)-EM0 +EMR-0.5*Q *X(IMAX))/(YMAX+WL(IMAX))
      IF(YB(IMAX).GT.YA(IMAX).AND.P1.GT.PLO) PLO=P1
      IF(YB(IMAX).LE.YA(IMAX).AND.P1.LT.PUP) PUP=P1
  351 IF(YB(IMAX).GT.YA(IMAX)) PUP=P
      IF(YB(IMAX).LE.YA(IMAX)) PLO=P
      P=(PUP+PLO)/2.0
      GO TO 90
  850 RETURN
  500 FORMAT(/,/, /,' --- POST-BUCKLING ---')
  501 FORMAT(6X,'CALLED IN PSBUCK')
  560 FORMAT(/,4X,'P =',E12.4)
  561 FORMAT(  5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(/,'  +++ CONVERGENCE',/////)
  900 FORMAT('  ***  TOO MANY ITERATIONS IN PSBUCK')
  905 FORMAT('  ***  M IS LARGER THAN 25')
  910 FORMAT('  ***  J IS LARGER THAN 15')
      END
      SUBROUTINE UNLOAD(IND,PDELT,EM0,Q,NEL,WL,NTH,YO)
C  NEWMARK'S METHOD FOR ELASTIC UNLOADING AND TENSIONING BRANCHES
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      COMMON /SPACE/ S0(10,99),ES0(10,99)
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      DIMENSION YA(20),WL(20),XAO(10,3),FAO(10,3),YO(20)
      KW=1
      IF(NEL.GT.10) KW=2
      DO 15 I=1,NEL+1
   15 YA(I)=YO(I)
      WRITE(6,400)
      WRITE(6,502) (X(I),I=1,NEL+1,KW)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      PUN=YY(KP)
C
      DO 100 IP=1,50
      P=0.98*PUN+PDELT*FLOAT(IP-1)
      IF(P.LT.PY) GO TO 75
      PRINT *,'  P IS GREATER THAN PY'
      GO TO 850
   75 WRITE(6,560) P
C  ITERATIVE PROCESS STARTS
      DO 3 J=1,NEL+1
      DO 3 I=1,3
      XAO(J,I)=XA(J,I)
    3 FAO(J,I)=FA(J,I)
      N=0
   90 N=N+1
      DO 7 J=1,NEL+1
      DO 7 I=1,3
      XA(J,I)=XAO(J,I)
    7 FA(J,I)=FAO(J,I)
      IF(N.LE.25) GO TO 80
      WRITE(6,900)
      GO TO 100
C
   80 CALL CYCLE(YA,P,EM0,Q,WL,NEL,IND,NTH,IFAC)
      IF(IFAC.NE.1)  GO TO 50
      DO 4 J=1,NEL+1
      DO 4 I=1,3
      XA(J,I)=XAO(J,I)
    4 FA(J,I)=FAO(J,I)
      GO TO 850
C
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
   55 IF(ABS(YB(I)).GT.YAA) YAA=ABS(YB(I))
      IF(YAA.LT.0.001) GO TO 314
      EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.01*YAA) GO TO 350
  314 WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      DO 20 I=1,NEL+1
      DO 20 L=1,NTH
      ES(I,L)=ES0(I,L)
   20 RSTA(I,L)=S0(I,L)
      WRITE(6,600)
      KP=KP+1
      YY(KP)= P
      IF(IND.NE.1) GO TO 10
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
   10 IF(IND.NE.2) GO TO 100
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*YAA) GO TO 315
      WRITE(6,910)
      GO TO 850
  315 DO 320 I=1,NEL+1
  320 YA(I)=YB(I)
      GO TO 90
  100 CONTINUE
  850 RETURN
  400 FORMAT(/////,'  --- ELASTIC UNLOADING AND TENSIONING ---')
  502 FORMAT(1H ,2X,'1X(I)',3X,10E12.4)
  560 FORMAT(1H ,/,/,/,2X,'P =',E13.4)
  561 FORMAT(1H ,/,5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(1H ,/,'==== CONVERGENCE')
  900 FORMAT(1H ,'***  TOO MANY ITERATIONS IN NEWMARK')
  910 FORMAT(1H ,/,'*** EROR GREATER THAN 50*YAA IN NEWMARK')
      END
      SUBROUTINE TENSPL(IND,EM0,Q,NEL,WL,NTH)
C  TENSION INCREASING BRANCH IN PLASTIC RANGE
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      COMMON /DATA/ EMY,PY,X(20),PHIY
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1         SLOPE0(20),YB(20),BM(20)
      COMMON /SPACE/ S0(10,99),ES0(10,99)
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      DIMENSION  YA(20),WL(20),XAO(10,3),FAO(10,3)
      M=0
      EMR=0.0
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,500)
      YC=XW(KP)-1.0
      DO 10 I=1,NEL+1
   10 YA(I)=YC*X(I)/X(NEL+1)
  110 P=YY(KP)
      IF(YA(NEL+1).LT.0.0) P=1.1*PY
      PLO=YY(KP)
      PUP=2.0*YY(KP)
      DO 3 J=1,NEL+1
      DO 3 I=1,3
      XAO(J,I)=XA(J,I)
    3 FAO(J,I)=FA(J,I)
C  REPEAT FOR DIFFERENT DEFLECTION
      IF(P.LT.PY) GO TO 105
  115 P=PY*0.98
      PS=0.98
      EMPC=1.82*(1.0-PS)
      YC=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(0.98*PY)-WL(NEL+1)
      IF(ABS(YB(NEL+1)-0.1).LT.0.01) GO TO 12
      IF(YC.LT.0.0) YC=0.1
   12 DO 15 I=1,NEL+1
   15 YA(I)=(YC+WL(NEL+1))*X(I)/X(NEL+1)-WL(I)
C  ITERATION FOR CONVERGENCE
      M=0
  105 M=M+1
      IF(M.LE.25) GO TO 95
      WRITE(6,905)
      GO TO 850
   95 N=0
   90 N=N+1
      DO 7 J=1,NEL+1
      DO 7 I=1,3
      XA(J,I)=XAO(J,I)
    7 FA(J,I)=FAO(J,I)
      IF(N.LE.15) GO TO 80
      PRINT *,'  *** TOO MANY ITERATIONS IN TENSPL'
      GO TO 850
   80 CONTINUE
      WRITE(6,560) P
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
C
      CALL CYCLE(YA,P,EM0,Q,WL,NEL,IND,NTH,IFAC)
C
      IF(IFAC.NE.1) GO TO 50
      WRITE(6,601)
      IF(P.LT.PUP)  PUP=P
      IF(PUP-PLO.LT.1.0E-3) PLO=.999 *PLO
      P=(PUP+PLO)/2.0
      IF(P.GT.PY) GO TO 115
      PRINT*,'  PLO=',PLO,' PUP=',PUP
      GO TO 105
C  JUDGEMENT OF CONVERGENCE
   50 EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.1 *YA(NEL+1).OR. PUP-PLO.GT.1.0) GO TO 350
      DO 311 I=1,NEL+1
  311 IF(ABS(YB(I)-YA(I)).GT.0.15*YA(I)) GO TO 350
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      DO 25 I=1,NEL+1
      DO 25 L=1,NTH
      ES(I,L)=ES0(I,L)
   25 RSTA(I,L)=S0(I,L)
      WRITE(6,600)
      KP=KP+1
      YY(KP)=P
      IF(IND.NE.1) GO TO 20
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
   20 IF(IND.NE.2) GO TO 100
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*ABS(YA(NEL+1)).OR.EROR.LT.50.0*ABS(YB(NEL+1)))
     1      GO TO 313
      WRITE(6,910)
      GO TO 850
  313 YAB=YA(NEL+1)*YB(NEL+1)
      IF(YAB.GT.0.0) GO TO 315
      PRINT *,'   ***  YB HAS OPPOSITE SIGN OF YA'
      IF(YB(NEL+1).LT.0.0) PUP=P
      IF(YB(NEL+1).GT.0.0) PLO=P
      P=(PUP+PLO)/2.0
      PRINT *,'                 PLO, PUP=',PLO,PUP
      IF(P.GT.PY) GO TO 115
      GO TO 105
  315 PS=P/PY
      EMPC=1.273*(1.0-1.18*PS*PS)
      IF(PS.GT.0.65) EMPC=1.82*(1.0-PS)
      P1=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(YA(NEL+1)+WL(NEL+1))
      P2=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(YB(NEL+1)+WL(NEL+1))
      IF(YA(NEL+1).LT.YB(NEL+1)) GO TO 318
      PUP=P
      IF(P2.LT.PUP.AND.P2.GT.PLO) PUP=P2
      GO TO 319
  318 PLO=P
      IF(N.GT.1.OR.M.GT.1) GO TO 319
      IF(P1.LT.PUP.AND.P1.GT.PLO) PUP=P1
      IF(P2.GT.PLO.AND.P2.LT.PUP) PLO=P2
  319 P=(PLO+PUP)/2.0
      IF(P.GT.PY) GO TO 115
      PRINT *,'  PLO, PUP=',PLO,PUP
      IF(EROR.GT.10.0*ABS(YA(NEL+1))) GO TO 90
      DO 320 I=1,NEL+1
      YAI=(YB(I)+WL(I))*(YA(NEL+1)+WL(NEL+1))/(YB(NEL+1)+WL(NEL+1))-
     1      WL(I)
      IF(YB(NEL+1).LT.YA(NEL+1)) YAI=YB(I)-(YB(NEL+1)-YA(NEL+1))*X(I)/
     1     X(NEL+1)
  320 YA(I)=(YAI+YA(I))/2.0
      GO TO 90
  100 RA=ABS(P-PY)/PY
      IF(RA.LT.0.025) GO TO 850
      IF(YA(NEL+1)+WL(NEL+1).LT.0.05) GO TO 850
      DO 325 I=1,NEL+1
  325 YA(I)=YB(I)-    X(I)/X(NEL+1)
      GO TO 110
  850 RETURN
  500 FORMAT(/////,'  --- PLASTIC TENSIONING ---')
  560 FORMAT(/,4X,'P=',E12.4)
  561 FORMAT(5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/,1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(/,'  \\\ CONVERGENCE',/,/,/)
  601 FORMAT(30X,'CALLED IN TENSPL')
  905 FORMAT('  *** M IS GREATER THAN 25')
  910 FORMAT(1H ,/,'  *** EROR GREATER THAN 50*YA(NEL+1) IN TENSPL')
      END
      SUBROUTINE CYCLE(YA,P,EM0,Q,WL,NEL,IND,NTH,IFAC)
C  CALCULATION OF 1-CYCLE OF ITERATION FOR NEWMARK'S METHOD
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      DIMENSION YA(20),WL(20),FB(3),DFA(3)
      DL=X(2)
      EMR=0.0
      DO 110 I=1,NEL+1
  110 BM(I)=EM0-EMR+0.5*Q*X(I)-P*(YA(I)+WL(I))
      KW=1
      IF(NEL.GT.10) KW=2
*     WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      DO 120 I=1,NEL+1
      FB(1)=BM(I)
      FB(2)=0.0
      FB(3)= P
      DO 1 L=1,3
    1 DFA(L)=FB(L)-FA(I,L)
C
      CALL CONVRG(FB,   DFA,IFAC,NTIME,I,NTH)
      IF(IFAC.EQ.1) GO TO 850
C
      PHI(I)=-XA(I,1)
      E0(I)=XA(I,3)
  120 CONTINUE
*     WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      ALPH(1)=DL/24.0*(7.0*PHI(1)+6.0*PHI(2)-PHI(3))
      ALPHE(1)=DL/24.0*(7.0*E0(1)+6.0*E0(2)-E0(3))
      DO 130 I=2,NEL
      ALPH(I)=DL/12.0*(PHI(I-1)+10.0*PHI(I)+PHI(I+1))
  130 ALPHE(I)=DL/12.0*(E0(I-1)+10.0*E0(I)+E0(I+1))
      ALPH(NEL+1)=DL/24.0*(7.0*PHI(NEL+1)+6.0*PHI(NEL)-PHI(NEL-1))
      ALPHE(NEL+1)=DL/24.0*(7.0*E0(NEL+1)+6.0*E0(NEL)-E0(NEL-1))
      IF(IND.NE.2) GO TO 20
      ALPH(NEL+1)=DL/12.0*(2.0*PHI(NEL)+10.0*PHI(NEL+1))
      ALPHE(NEL+1)=DL/12.0*(2.0*E0(NEL)+10.0*E0(NEL+1))
   20 CONTINUE
*     WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
*     WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
C  SLOPE FOR ASYMMETRY COLUMN
      IF(IND.EQ.2) GO TO 200
      ATOT=0.0
      DO 30 I=1,NEL+1
   30 ATOT=ATOT-ALPH(I)
      SLOPE(1)=ATOT/2.0
      DO 140 I=2,NEL
  140 SLOPE(I)=SLOPE(I-1)+ALPH(I)
      GO TO 210
C  SLOPE FOR SYMMETRY COLUMN
  200 SLOPE(NEL)=-ALPH(NEL+1)/2.0
      DO 220 I=1,NEL-1
      L=NEL-I
  220 SLOPE(L)=SLOPE(L+1)-ALPH(L+1)
  210 CONTINUE
*     WRITE(6,569) (SLOPE(I),I=1,NEL,KW)
      YB(1)=0.0
      DO 230 I=2,NEL+1
  230 YB(I)=YB(I-1)+SLOPE(I-1)*DL
      IF(IND.EQ.2) GO TO 300
      DY=YB(NEL+1)/FLOAT(NEL)
      DO 50 I=1,NEL
   50 YB(I+1)=YB(I+1)-DY*FLOAT(I)
  300 CONTINUE
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      SLOPE0(1)=0.0
      ALPHE(1)=2.0*ALPHE(1)
      IF(IND.EQ.1) ALPHE(NEL+1)=2.0*ALPHE(NEL+1)
      DO 145 I=2,NEL+1
      DL2=(YB(I-1)-YB(I))**2
      DELTA=DL-SQRT(DL*DL-DL2)
  145 SLOPE0(I)=SLOPE0(I-1)+(ALPHE(I-1)+ALPHE(I))/2.0-DELTA
*     WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
  850 RETURN
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
      END
      SUBROUTINE CONVRG(FB,   DFA,IFAC,N,II,NTH)
C  JUDGE CONVERGENCE AND ADJUST LOAD INCREMENT WHEN IT'S TOO LARGE
      COMMON /AFORCE/ FA(10,3),XA(10,3)
      DIMENSION FB(3),DFA(3),FAO(3),XAO(3),QG(3,3),DXA(3),QI(3,3)
      DO 3 I=1,3
      XAO(I)=XA(II,I)
    3 FAO(I)=FA(II,I)
      ERR=0.01
      N=0
C
   10 CALL STIFF(QG,XA,   NTH,II)
      CALL INVERS(QI,QG,IFAC)
      IF(IFAC.GT.0) GO TO 102
C  WHEN IFAC=1, STIFFNESS MATRIX IS SINGULAR
C
      CALL MULT1(QI,DFA,3,DXA)
C
      DO 1 K=1,3
    1 XA(II,K)=XA(II,K)+DXA(K)
      CALL STRESS(FA,XA,   NTH,II)
      ERRF=0.0
      DO 2 K=1,3
      DFA(K)=FB(K)-FA(II,K)
    2 IF(ABS(DFA(K)).GT.ABS(ERRF)) ERRF=DFA(K)
      N=N+1
      IF(N.GT.15) GO TO 101
      IF(ABS(ERRF).GT.ERR) GO TO 10
C
      GO TO 200
  101 WRITE(6,501)
C
  102 DO 105 I=1,3
      XA(II,I)=XAO(I)
  105 FA(II,I)=FAO(I)
  200 RETURN
  501 FORMAT(1H ,5X,'***  TOO MANY ITERATION TIMES')
      END
      SUBROUTINE STIFF(QG,XA,   NTH,II)
C  GENERATE STIFFNESS MATRIX
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /MAT/ E,SY,D,T,DA
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      DIMENSION Q(3,3),QG(3,3),XA(10,3)
C   EA=STRAIN
C   EY1= UPPER LIMIT OF ELASTIC STRAIN
C   EY2= LOWER LIMIT OF ELASTIC STRAIN
C   Q = ELEMENT OF STIFFNESS MATRIX FOR A SEGMENT
C   QG= ELEMENT OF GLOBAL STIFFNESS MATRIX
C
      DO 10 K=1,3
      DO 10 L=1,3
   10 QG(K,L)=0.0
      DO 20 I=1,NTH
      X=X0(I)
      Y=Y0(I)
      EA=Y*XA(II,1)-X*XA(II,2)+XA(II,3)
C
      EY1=ES(II,I)+(SY-RSTA(II,I))/E
      EY2=ES(II,I)+(-SY-RSTA(II,I))/E
      IF(EA.GT.EY2.AND.EA.LT.EY1) EFF=E
      IF(EA.GT.EY1. OR.EA.LT.EY2) EFF=0.0
      Q(1,1)=EFF*Y*Y*DA
      Q(2,2)=EFF*X*X*DA
      Q(3,3)=EFF*DA
      Q(1,2)=-EFF*X*Y*DA
      Q(2,1)=Q(1,2)
      Q(1,3)=EFF*Y*DA
      Q(3,1)=Q(1,3)
      Q(2,3)=-EFF*X*DA
      Q(3,2)=Q(2,3)
      DO 1 K=1,3
      DO 1 L=1,3
    1 QG(K,L)=QG(K,L)+Q(K,L)
   20 CONTINUE
      RETURN
      END
      SUBROUTINE STRESS(FA,XA,   NTH,II)
C INTEGRATE STRESS OF A ELEMENT IN ORDER TO OBTAIN SECTION FORCES
      COMMON /COORD/ X0(150),Y0(150)
      COMMON /MAT/ E,SY,D,T,DA
      COMMON /RESIST/ RSTA(10,99),ES(10,99)
      COMMON /SPACE/ S0(10,99),ES0(10,99)
      DIMENSION FA(10,3),XA(10,3)
C   ES0= CURRENT STATE OF STRAIN
C   S0 = CURRENT STATE OF STRESS
      DO 1 K=1,3
    1 FA(II,K)=0.0
      DO 10 I=1,NTH
      X=X0(I)
      Y=Y0(I)
      EA=Y*XA(II,1)-X*XA(II,2)+XA(II,3)
      ES0(II,I)=EA
      EY1=ES(II,I)+(SY-RSTA(II,I))/E
      EY2=ES(II,I)+(-SY-RSTA(II,I))/E
      IF(EA.GT.EY2.AND.EA.LT.EY1) S0(II,I)=RSTA(II,I)+E*(EA-ES(II,I))
      IF(EA.GE.EY1) S0(II,I)=SY
      IF(EA.LE.EY2) S0(II,I)=-SY
      FA(II,1)=FA(II,1)+S0(II,I)*Y*DA
      FA(II,2)=FA(II,2)-S0(II,I)*X*DA
   10 FA(II,3)=FA(II,3)+S0(II,I)*DA
      RETURN
      END
      SUBROUTINE INVERS(AI,A,IFAC)
C          GET INVERSE MATRIX AI FROM A
C          IFAC=1.... STIFFNESS MATRIX IS SINGULAR
      DIMENSION  AI(3,3),A(3,3)
C      *** DETERMINANT  A
      ADET1=A(1,1)*A(2,2)*A(3,3)+A(1,2)*A(2,3)*A(3,1)+A(2,1)*A(3,2)
     1       *A(1,3)
      ADET2=A(1,3)*A(2,2)*A(3,1)+A(1,2)*A(2,1)*A(3,3)+A(2,3)*A(3,2)
     1      *A(1,1)
      ADET=ADET1-ADET2
      IFAC=0
      IF(ABS(ADET).GT.1.0E-10) GO TO 50
       IF(ADET.GE.0.0) ADET=1.0E-10
       IF(ADET.LT.0.0) ADET=-1.0E-10
      WRITE(6,500)
      IFAC=1
   50 AI(1,1)=A(2,2)*A(3,3)-A(2,3)*A(3,2)
      AI(1,2)=A(2,1)*A(3,3)-A(2,3)*A(3,1)
      AI(1,2)=-AI(1,2)
      AI(1,3)=A(2,1)*A(3,2)-A(2,2)*A(3,1)
      AI(2,1)=A(1,2)*A(3,3)-A(1,3)*A(3,2)
      AI(2,1)=-AI(2,1)
      AI(2,2)=A(1,1)*A(3,3)-A(1,3)*A(3,1)
      AI(2,3)=A(1,1)*A(3,2)-A(1,2)*A(3,1)
      AI(2,3)=-AI(2,3)
      AI(3,1)=A(1,2)*A(2,3)-A(1,3)*A(2,2)
      AI(3,2)=A(1,1)*A(2,3)-A(1,3)*A(2,1)
      AI(3,2)=-AI(3,2)
      AI(3,3)=A(1,1)*A(2,2)-A(1,2)*A(2,1)
      DO 10 I=1,3
      DO 10 J=1,3
   10 AI(I,J)=AI(I,J)/ADET
      RETURN
  500 FORMAT(1H ,'**** STIFFNESS MATRIX IS SINGULAR')
      END
      SUBROUTINE  MULT1(A,B,M,C)
C      *** C(M)=A(M*M)*B(M)
      DIMENSION  A(M,M),B(M),C(M)
      DO 1 I=1,M
      C(I)=0.0
      DO 1 J=1,M
      C(I)=C(I)+A(I,J)*B(J)
    1 CONTINUE
      RETURN
      END
