C     PROGRAM FIXCYCL(INPUT,OUTPUT,PLOT,TAPE5=INPUT,TAPE6=OUTPUT)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
C  MCT=0... PLASTIC MOMENT
C  MCT=1... AVERAGE PLASTIC MOMENT BY REPORT NO. 2
C  MCT=2... AVERAGE FLOW MOMENT BY ATSUTA@S MODIFICATION FACTOR
      DIMENSION TITLE(20)
      OPEN (UNIT=5,FILE='FIXDATA')
      OPEN (UNIT=6,FILE='FIXRESL')
C     CALL PLOTS
C     CALL PLOT(10.0,5.0,-3)
C     CALL AXIS(-10.0,0.0,38HSHORTENING AND  DEFLECTION  (IN),-38,
C    1   14.0,0.0,-10.0,1.0,0)
C     CALL AXIS(0.0,-5.0,49HAXIAL FORCE (1KIPS),49,10.0,90.0,-1.0,10.0,-1)
C
   50 READ(5,150,END=999) (TITLE(I),I=1,17),MCT
  150 FORMAT(17A4,I4)
      WRITE(6,400) (TITLE(I),I=1,17)
  403 FORMAT(//,5X,'MCT =',I3)
      WRITE(6,403) MCT
      READ(5,*)   AL,D,T,SY,YONG
      WRITE(6,405)AL,D,T,SY,YONG
  400 FORMAT(1H ,18A4)
  405 FORMAT(//,5X,'AL=',E12.4,'  D=',E12.4,'  T=',E12.4,'  SY=',E12.4,
     1       '  YONG=',E12.4)
      AL=12.0*AL
      PAI=4.0*ATAN(1.0)
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)
      SA=PAI/4.0*(D*D-(D-2.0*T)**2)
      RG=SQRT(SI/SA)
      SL=AL/RG
      PY=SY*SA
      EMY=SY*SI*2.0/D
      READ(5,*)    PP,PDELT,QQ,QDELT,NQ,AX,YLMT
      WRITE(6,410) PP,PDELT,QQ,QDELT,NQ,AX,YLMT
  410 FORMAT( /,5X,'PP=',E12.4,'  PDELT=',E12.4,'   QQ=',E12.4,
     1   '  QDELT=',E12.4,'  NQ=',I3,'   AX=',E12.4,'   YLMT=',E12.4)
      AX=12.0*AX
      QY=4.0*AL*EMY/(AX*(2.0*AL-AX))
      PBUCK=PAI*PAI*YONG*SI/AL/AL
      WRITE(6,420) SI,SA,PY,EMY,QY,PBUCK,SL
  420 FORMAT(//,5X,'SI=',E11.4,'   SA=',E11.4,'   PY=',E11.4,'   EMY=',
     1        E11.4,'  QY=',E11.4,'  PBUCK=',E11.4,'  SL=',E11.4)
      IF(PBUCK.GT.PY) PBUCK=PY
C
      DO 100 I=1,NQ
      Q=QQ+QDELT*FLOAT(I-1)
      CALL COMELS(Q,PP,PDELT,AL,AX,MCT)
      CALL COMPLS(Q,AL,AX,THE,THC,PDELT,YLMT,MCT)
      CALL COMUNL(Q,AL,AX,THE,THC,MCT)
      CALL TENELS(Q,AL,AX,THE,THC,PDELT,MCT)
      CALL TENPLS(Q,AL,AX,MCT)
  100 CONTINUE
      P(KP+1)=0.0
      P(KP+2)=10.0
      Y(KP+1)=0.0
      Y(KP+2)=1.0
      S(KP+1)=0.0
      S(KP+2)=0.1
C     CALL DSHLINE(Y,P,KP,0.2,0.08,1)
C     CALL DSHLINE(S,P,KP,0.0,0.0,0)
C     GO TO 50
  999 CALL PLOT(0.0,0.0,999)
      STOP
      END
      SUBROUTINE COMELS(Q,PP,PDELT,AL,AX,MCT)
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      REAL K
      WRITE(6,500)
  500 FORMAT(/////,5X,90('*'),//,
     1           5X,'(1)... INITIAL ELASTIC LOADING IN COMPRESSION')
      WRITE(6,509)
  509 FORMAT(/,10X,'Q',14X,'P',14X,'Y',14X,'S',13X,'MR',13X,'MC',12X,
     1     'MPC',14X,'KP')
      QS=Q/QY
      FN=4.0/(1.0+QS)
      F2=2.0*SL/70.0
      F3=0.5
      KP=0
C
      DO 10 I=1,50
      KP=KP+1
      P(KP)=-PP-PDELT*FLOAT(I-1)
      PF=-P(KP)
      K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 20
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   20 EMR=0.5*Q/K*(COS(V)/TAN(U)+SIN(V)-1.0/TAN(U))
      A=Q/(2.0*PF*K)
      B=-EMR/PF
      C=A-Q*COS(V)/(2.0*PF*K)
      D=B+Q*SIN(V)/(2.0*PF*K)
      Y(KP)=C*SIN(U)+D*COS(U)-0.5*Q*AX/PF+EMR/PF
      EMC=-EMR+0.5*Q*AX+PF*Y(KP)
      S(KP)=(PF*AL/YONG/SA+(1.0-COS(Y(KP)/AL))*AL)*(-2.0)
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMR,EMC,EMPC,KP
      IF(EMR.GT.EMPC.AND.EMC.GT.EMPC) GO TO 850
      IF(EMR.GT.EMPC.AND.EMC.LT.EMPC) GO TO 30
      IF(EMC.GT.EMPC.AND.EMR.LT.EMPC) GO TO 50
   10 CONTINUE
      PRINT*,'   *** NO HINGE IS FORMED ***'
      GO TO 850
C
C  HINGE FORMED AT ENDS
   30 KP=KP-1
      WRITE(6,501)
  501 FORMAT(//,5X,'(2)... HINGE FORMED AT ENDS IN COMPRESSION')
      WRITE(6,509)
      PK=P(KP)
      DO 40 I=1,40
      KP=KP+1
      P(KP)=PK-FLOAT(I-1)*PDELT/3.0
      PF=-P(KP)
      K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 35
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   35 C=(-EMPC/PF+Q*SIN(V)/(2.0*PF*K))*TAN(U)
      D=-EMPC/PF+Q*SIN(V)/(2.0*PF*K)
      Y(KP)=C*SIN(U)+D*COS(U)-0.5*Q*AX/PF+EMPC/PF
      EMC=-EMPC+PF*Y(KP)+0.5*Q*AX
      S(KP)=(PF*AL/YONG/SA+(1.0-COS(Y(KP)/AL))*AL)*(-2.0)
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMPC,EMC,EMPC,KP
      IF(EMC.GT.EMPC) GO TO 850
      IF(Y(KP).LT.Y(KP-1).AND.ABS(P(KP)).GT.ABS(PK-PDELT)) GO TO 850
   40 CONTINUE
      GO TO 850
C
C  HINGE FORMED AT CENTER
   50 KP=KP-1
      WRITE(6,502)
  502 FORMAT(//,5X,'(2)... HINGE FORMED AT CENTER IN COMPRESSION')
      WRITE(6,509)
      PK=P(KP)
      DO 60 I=1,40
      KP=KP+1
      P(KP)=PK-FLOAT(I-1)*PDELT/3.0
      PF=-P(KP)
      K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 55
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   55 Y(KP)=-EMPC/PF*(1.0/COS(U)-1.0)+Q/(2.0*K*PF)*(TAN(U)-COS(V)*TAN(U)
     1      +SIN(V)-V)
      EMR=-EMPC+PF*Y(KP)+Q*AX/2.0
      EMC=-EMR+Q*AX/2.0+PF*Y(KP)
      S(KP)=(PF*AL/YONG/SA+(1.0-COS(Y(KP)/AL))*AL)*(-2.0)
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMR,EMC,EMPC,KP
      IF(EMR.GT.EMPC) GO TO 850
  510 FORMAT(1H ,7E15.4, 8X,I3)
   60 CONTINUE
  850 RETURN
      END
      SUBROUTINE COMPLS(Q,AL,AX,THE,THC,PDELT,YLMT,MCT)
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      REAL K
      WRITE(6,503)
  503 FORMAT(//,5X,'(3)... BOTH HINGES FORMED AT ENDS AND CENTER IN COMP
     1RESSION')
      WRITE(6,511)
  511 FORMAT(/,10X,'Q',14X,'P',14X,'Y',14X,'S',12X,'THE',12X,'THC',12X,
     1     'MPC',14X,'KP')
      QS=Q/QY
      FN=4.0/(1.0+QS)
      F2=2.0*SL/70.0
      F3=0.5
      PK=P(KP)
      N=0
   10 N=N+1
      IF(N.LT.50) GO TO 20
      PRINT*,'   ****  N IS GREATER THAN 50'
      GO TO 850
   20 KP=KP+1
      P(KP)=PK+PDELT/2.0*FLOAT(N-1)
   30 PF=-P(KP)
      K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 40
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   40 Y(KP)=(2.0*EMPC-Q*AX/2.0)/PF
      IF(Y(KP).GT.YLMT) GO TO 60
      S(KP)=(PF*AL/YONG/SA+(1.0-COS(Y(KP)/AL))*AL)*(-2.0)
      D=-EMPC/PF+Q/(2.0*PF*K)*SIN(V)
      C=(EMPC/PF-D*COS(U))/SIN(U)
      A=C+Q/(2.0*PF*K)*COS(V)
      THE=A*K-Q/(2.0*PF)
      THC=C*K*COS(U)-D*K*SIN(U)
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),THE,THC,EMPC,KP
  510 FORMAT(1H ,7E15.4, 8X,I3)
      IF(THE.LT.0.0.AND.THC.LT.0.0) KP=KP-1
      IF(N.LT.0) GO TO 850
      GO TO 10
   60 P(KP)=(2.0*EMPC-Q*AX/2.0)/(-YLMT)
      N=-1
      GO TO 30
  850 RETURN
      END
      SUBROUTINE COMUNL(Q,AL,AX,THE,THC,MCT)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
      REAL K
      WRITE(6,504)
  504 FORMAT(//,5X,'(4)... ELASTIC UNLOADING IN COMPRESSION')
      WRITE(6,509)
  509 FORMAT(/,10X,'Q',14X,'P',14X,'Y',14X,'S',13X,'MR',13X,'MC',12X,
     1     'MPC',14X,'KP')
      QS=Q/QY
      FN=4.0/(1.0+QS)
      F2=2.0*SL/70.0
      F3=0.5
      PDEL =P(KP)/5.0
      PK=P(KP)
      DO 10 I=1,5
      KP=KP+1
      P(KP)=PK-PDEL *FLOAT(I-1)
      PF=-P(KP)
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 20
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   20 K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      EMR=PF/(K*SIN(U))*(Q/(2.0*PF)*(SIN(V)*SIN(U)+COS(V)*COS(U)-COS(U))
     1     +THC-THE*COS(U))
      C=THE/K+Q*(1.0-COS(V))/(2.0*K*PF)
      D=-EMR/PF+Q*SIN(V)/(2.0*PF*K)
      Y(KP)=C*SIN(U)+D*COS(U)-0.5*Q*AX/PF+EMR /PF
      S(KP)=(PF*AL/YONG/SA+(1.0-COS(Y(KP)/AL))*AL)*(-2.0)
      EMC=-EMR+Q*AX/2.0+PF*Y(KP)
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMR,EMC,EMPC,KP
  510 FORMAT(1H ,7E15.4, 8X,I3)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE TENELS(Q,AL,AX,THE,THC,PDELT,MCT)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
      REAL K,H
      WRITE(6,505)
  505 FORMAT(//,5X,'(5)... ELASTIC LOADING IN TENSION')
      WRITE(6,509)
      QS=Q/QY
      FN=4.0/(1.0+QS)
      F2=2.0*SL/70.0
      F3=0.5
C
      DO 10 I=1,40
      KP=KP+1
      P(KP)=PDELT*FLOAT(I)
      PF=P(KP)
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 20
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   20 K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      EUN=EXP(-U)
      EU =EXP( U)
      EVN=EXP(-V)
      EV =EXP( V)
      A1=2.0*PF/K*THC+Q/2.0/K*((1.0-EV)*EUN+(1.0-EVN)*EU)
      A2=PF/K*THE*(EU+EUN)
      EMR=(A1-A2)/(EU-EUN)
      E=EMR/2.0/PF-Q/(4.0*PF*K)+THE/2.0/K
      F=EMR/2.0/PF+Q/(4.0*PF*K)-THE/2.0/K
      G=E+Q/(4.0*K*PF)*EVN
      H=F-Q/(4.0*K*PF)*EV
      Y(KP)=G*EU+H*EUN+Q*AX/2.0/PF-EMR/PF
      EMC=-EMR+Q*AX/2.0-PF*Y(KP)
      S(KP)=(PF*AL/YONG/SA-(1.0-COS(Y(KP)/AL))*AL)*2.0
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMR,EMC,EMPC,KP
      IF(ABS(EMR).GT.EMPC.AND.ABS(EMC).LT.EMPC) GO TO 30
      IF(ABS(EMC).GT.EMPC.AND.ABS(EMR).LT.EMPC) GO TO 50
      IF(ABS(EMR).GT.EMPC.AND.ABS(EMC).GT.EMPC) GO TO 850
  510 FORMAT(1H ,7E15.4, 8X,I3)
   10 CONTINUE
      PRINT*,'  *** NO HINGE IS FORMED ***'
      GO TO 850
C
C  HINGE FORMED AT ENDS IN TENSION
   30 KP=KP-1
      WRITE(6,506)
  506 FORMAT(//,5X,'(6)... HINGE FORMED AT ENDS IN TENSION')
      WRITE(6,509)
      PK=P(KP)
      DO 40 I=1,30
      KP=KP+1
      P(KP)=PK+FLOAT(I-1)*PDELT/3.0
      PF=P(KP)
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 35
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   35 K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      EUN=EXP(-U)
      EU =EXP( U)
      EVN=EXP(-V)
      EV =EXP( V)
      A1=THC/K-EMPC/PF*EUN
      A2=Q/(4.0*K*PF)*(EVN*EU+EV*EUN)
      E=(A1-A2)/(EU+EUN)
      F=-EMPC/PF-E
      G=E+Q*EVN/(4.0*K*PF)
      H=F-Q*EV/(4.0*K*PF)
      Y(KP)=G*EU+H*EUN+Q*AX/2.0/PF+EMPC/PF
      EMC=EMPC+Q*AX/2.0-PF*Y(KP)
      S(KP)=(PF*AL/YONG/SA-(1.0-COS(Y(KP)/AL))*AL)*2.0
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMPC,EMC,EMPC,KP
      IF(ABS(EMC).GT.EMPC) GO TO 850
   40 CONTINUE
      GO TO 850
C
C  HINGE FORMED AT CENTER IN TENSION
   50 KP=KP-1
      WRITE(6,507)
  507 FORMAT(//,5X,'(6)... HINGE FORMED AT CENTER IN TENSION')
      WRITE(6,509)
  509 FORMAT(/,10X,'Q',14X,'P',14X,'Y',14X,'S',13X,'MR',13X,'MC',12X,
     1     'MPC',14X,'KP')
      PK=P(KP)
      DO 60 I=1,30
      KP=KP+1
      P(KP)=PK+FLOAT(I-1)*PDELT/3.0
      PF=P(KP)
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 55
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   55 K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      EUN=EXP(-U)
      EU =EXP( U)
      EVN=EXP(-V)
      EV =EXP( V)
      A1=2.0*EMPC+Q/2.0/K*((1.0-EVN)*EU-(1.0-EV)*EUN)
      A2=PF*THE/K*(EU-EUN)
      EMR=(A1-A2)/(EU+EUN)
      E=EMR/2.0/PF+THE/2.0/K-Q/(4.0*PF*K)
      F=EMR/2.0/PF-THE/2.0/K+Q/(4.0*PF*K)
      G=E+Q/(4.0*K*PF)*EVN
      H=F-Q/(4.0*K*PF)*EV
      Y(KP)=G*EU+H*EUN+Q*AX/2.0/PF-EMR/PF
      EMC=-EMR+Q*AX/2.0-PF*Y(KP)
      S(KP)=(PF*AL/YONG/SA-(1.0-COS(Y(KP)/AL))*AL)*2.0
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),EMR,EMC,EMPC,KP
      IF(ABS(EMR).GT.EMPC) GO TO 850
   60 CONTINUE
  850 RETURN
      END
      SUBROUTINE TENPLS(Q,AL,AX,MCT)
      COMMON /DATA/ EMY,PY,SI,YONG,SA,QY,PBUCK,SL
      COMMON /RESULT/ KP,P(150),Y(150),S(150)
      REAL K,H
      WRITE(6,508)
  508 FORMAT(//,5X,'(7)... BOTH HINGES FORMED AT ENDS AND CENTER IN TENS
     1ION')
      WRITE(6,511)
  511 FORMAT(/,10X,'Q',14X,'P',14X,'Y',14X,'S',12X,'THE',12X,'THC',12X,
     1     'MPC',14X,'KP')
      QS=Q/QY
      FN=4.0/(1.0+QS)
      F2=2.0*SL/70.0
      F3=0.5
      PK=P(KP)
      PDELT=(PY-PK)/5.0
      DO 10 I=1,6
      KP=KP+1
      P(KP)=PK+PDELT*FLOAT(I-1)
      PF=P(KP)
      PS=PF/PY
      EMPC=1.299*(1.0-1.18*PS*PS)*EMY
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)*EMY
      IF(MCT.EQ.0) GO TO 20
      F1=(PF/PBUCK)**FN
      FM=F1*F2*F3
      IF(MCT.EQ.2) FM=0.5*PF/PY
      IF(FM.GT.1.0.OR.FM.LT.0.0) PRINT*,'  *** FM=',FM
      EMYC=(1.0-PS)*EMY
      EMPC=EMPC-FM*(EMPC-EMYC)
   20 K=SQRT(PF/SI/YONG)
      U=K*AL
      V=K*AX
      EUN=EXP(-U)
      EU =EXP( U)
      EVN=EXP(-V)
      EV =EXP( V)
      A1=EMPC*(1.0+EUN)/PF
      A2=Q/(4.0*K*PF)*(EV*EUN-EVN*EU)
      E=(A1+A2)/(EU-EUN)
      F=-E-EMPC/PF
      G=E+Q*EVN/(4.0*K*PF)
      H=F-Q*EV/(4.0*K*PF)
      Y(KP)=G*EU+H*EUN+Q*AX/2.0/PF+EMPC/PF
      S(KP)=(PF*AL/YONG/SA-(1.0-COS(Y(KP)/AL))*AL)*2.0
      THE=E*K-F*K+Q/2.0/PF
      THC=G*K*EU-H*K*EUN
      WRITE(6,510) Q, P(KP),Y(KP),S(KP),THE,THC,EMPC,KP
  510 FORMAT(1H ,7E15.4, 8X,I3)
   10 CONTINUE
      RETURN
      END
