C     PROGRAM APCYCL(INPUT,OUTPUT,PLOT,TAPE5=INPUT,TAPE6=OUTPUT)
C
      COMMON /APLOT/ PY,WYILD,DYILD
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION WL(20),YA(20),YO(20),PHIS(20),BMS(20),EIS(20)
      INTEGER CTRL
      OPEN (UNIT=5,FILE='APDATA')
      OPEN (UNIT=6,FILE='APRESL')
C     CALL PLOTS
C     CALL PLOT(10.0,5.0,-3)
      CALL AXIS(-10.0,0.0,38HSHORTENING       AND  DEFLECTION  W/WY,-38,
     1     14.0,0.0,-10.0,1.0,0)
      CALL AXIS(0.0,-5.0,47H                              AXIAL FORCE  P
     1/PY,47,10.0,90.0,-1.0,0.2,-1)
C
   10 CALL INPUT(IND,IWQ,QR,AL,D,T,SY,E,PP,PDELT,NP,EM0S,QS,NEL,WL,YLMT,
     1             NQS)
      CTRL=1
      IF(IND.EQ.3.OR.IND.EQ.4) CTRL=2
      IF(IND.EQ.6.OR.IND.EQ.8) CTRL=2
C
      CALL DATAGE(IND,AL,D,T,SY,E,QS,EM0S,NEL,PCR)
C
      CALL PRBUCK(IND,IWQ,QR,AL,D,T,SY,E,PP,PDELT,NP,EM0S,QS,NEL,WL,PCR,
     1           YA,P,YO,NQS)
C
      CALL PSBUCK(YO,P,IWQ,QR,NEL,EM0S,QS,WL,IND,D,T,E,SY,AL,YLMT,NQS,
     1      YA)
C
      IF(CTRL.EQ.2) GO TO 50
      CALL UNLOAD(IND,IWQ,QR,D,T,SY,E,PDELT,EM0S,QS,NEL,WL,PHIS,BMS,
     1       EIS,PIS,NQS,P)
C
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 40
      CALL TENSPL(IND,IWQ,QR,D,T,SY,E,EM0S,QS,NEL,WL,PHIS,BMS,EIS,PIS,
     1       NQS)
      GO TO 50
   40 CALL       UPQSPL(P,IWQ,QR,NEL,EM0S,QS,WL,IND,D,T,E,SY,AL,YLMT,
     1     NQS,YA,PHIS,BMS,EIS,PIS)
C
   50 IF(IND.EQ.5.OR. IND.EQ.6) GO TO 60
      DO 20 I=1,KP
      YY(I)=YY(I)/PY
      XW(I)=-XW(I)/WYILD
   20 XS(I)=XS(I)/DYILD
   60 YY(KP+1)=0.0
      YY(KP+2)=0.2
      XW(KP+1)=0.0
      XW(KP+2)=1.0
      XS(KP+1)=0.0
      XS(KP+2)=1.0
      PRINT*,'  KP=',KP
      PRINT*,'  YY(I),  XW(I),  XS(I)'
      WRITE(6,500) (YY(I1),I1=1,100)
      WRITE(6,500) (XW(I1),I1=1,100)
      WRITE(6,500) (XS(I1),I1=1,100)
      CALL DSHLINE(XW,YY,KP,0.2,0.08,1)
      CALL DSHLINE(XS,YY,KP,0.0,0.0,0)
      GO TO 10
  500 FORMAT(1H ,//, 5(1X,10E12.4,/),/,5(1X,10E12.4,/))
      END
      SUBROUTINE INPUT(IND,IWQ,QR,AL,D,T,SY,E,PP,PDELT,NP,EM0S,QS,NEL,WL
     1    ,YLMT,NQS)
      DIMENSION  WL(20),TITLE(20)
C  IND=1... ASYMMETRIC COLUMN ANALYSIS, 1-CYCLE OF LOADING
C  IND=2... SYMMETRIC  COLUMN ANALYSIS, 1-CYCLE OF LOADING
C   IND=3... ASYMMETRIC COLUMN ANALYSIS, BUCKLING BEHAVIOR
C   IND=4... SYMMETRIC COLUMN ANALYSIS, BUCKLING BEHAVIOR
C   IND=5... CENTER LOAD INCREASING, 1-CYCLE OF LOADING
C   IND=6... CENTER LOAD INCREASING, BUCKLING BEHAVIOR
C   IND=7... FIXED-ENDS, 1-CYCLE OF LOADING
C   IND=8... FIXED-ENDS, BUCKLING BEHAVIOR
C  IWQ=0... NO RESIDUAL STRESS AND NO HYDROSTATIC PRESSURE
C  IWQ=1... WITH RESIDUAL STRESS BUT NO HYDROSTATIC PRESSURE
C  IWQ=2... WITH RESIDUAL STRESS AND HYDROSTATIC PRESSURE
C  IWQ=3... CURVE FITTING TO SHERMAN'S TEST RESULT
C  IWQ=4... SYMMETRIC CURVE WITHOUT RESIDUAL STRESS
C  IWQ=5... SYMMETRIC CURVE WITH    RESIDUAL STRESS
C  IWQ=6... STRAIGHT UNLOADING LINES WITHOUT RESIDUAL STRESS FOR VIRGIN
C       CURVE
C  IWQ=7... STRAIGHT UNLOADING LINES WITH RESIDUAL STRESS FOR VIRGIN CUR
      PAI=4.0*ATAN(1.0)
      READ(5,100) (TITLE(I),I=1,15),IND,IWQ,QR
      WRITE(6,400) (TITLE(I),I=1,15)
      READ(5,*) AL,D,T,SY,E,NEL
      WRITE(6,405) IND,IWQ,QR,AL,D,T,SY,E,NEL
      AL=12.0*AL
      READ(5,*)    PP,PDELT,NP,EM0S,QS,NQS,YLMT
      IF(IND.EQ.5.OR.IND.EQ.6)  GO TO 30
      WRITE(6,410) PP,PDELT,NP,EM0S,QS,NQS,YLMT
      GO TO 40
   30 WRITE(6,420) PP,PDELT,NP,EM0S,QS,    YLMT
   40 PL=AL
      IF(IND.EQ.2.OR.IND.EQ.4) PL=2.0*AL
      IF(IND.GE.5) PL=2.0*AL
C  NCW=1... INITIAL DEFLECTION IS SINUSOIDAL WITH THE AMPLITUDE A=WL(1)*PL
C  NCW=2... WL(I)=WL(I)*PL
      READ(5,*) NCW,(WL(I),I=1,NEL+1)
      IF(NCW.NE.1) GO TO 10
      A=WL(1)*PL
      DO 12 I=1,NEL+1
      WL(I)=A*SIN(PAI*FLOAT(I-1)/FLOAT(NEL)*0.5)
      IF(IND.EQ.1.OR.IND.EQ.3) WL(I)=A*SIN(PAI*FLOAT(I-1)/FLOAT(NEL))
   12 IF(IND.EQ.7.OR.IND.EQ.8) WL(I)=0.5*A*(1.0-COS(PAI*FLOAT(I-1)/
     1      FLOAT(NEL)))
   10 IF(NCW.NE.2) GO TO 25
      DO 15 I=1,NEL+1
   15 WL(I)=WL(I)*PL
   25 WRITE(6,520)  NCW
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,521) (WL(I),I=1,NEL+1,KW)
      RETURN
C 999 CALL PLOT(0.0,0.0,999)
      STOP
  100 FORMAT(15A4,2I2,2F4.0)
  400 FORMAT(1H ,///,2X,15A4)
  405 FORMAT(1H ,3X,'IND=',I2,'  IWQ=',I2,'   QR=',F5.2,//,4X,'AL=',
     1    E12.4,'  D=',E12.4,'  T=',E12.4,'  SY=',E12.4,'  E=',E12.4,
     2     '    NEL=',I3)
  410 FORMAT(1H ,/,6X,'P=',E12.4,'  PDELT=',E12.4,'  NP=',I3,'  EM0S=',
     1   E12.4,'  QS=',E12.4,'    NQS=',I3,'  Y(LIMIT)=',E12.4)
  420 FORMAT(1H ,/,6X,'Q=',E12.4,'   QDELT=',E12.4,'NQ=',I3,'   EM0S=',
     1    E12.4,'   PS=',E12.4,'   Y(LIMIT)=',E12.4)
  520 FORMAT(1H ,/,5X,'INITIAL OUT-OF-STRAIGHTNESS      NCW=',I2)
  521 FORMAT(1H ,5X,'WL(I)=',10E11.3)
      END
      SUBROUTINE DATAGE(IND,AL,D,T,SY,E,QS,EM0S,NEL,PCR)
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /APLOT/ PZ,WYILD,DYILD
C  DATA GENERATION FOR THE MEMBER FROM THE INPUTS
      PAI=4.0*ATAN(1.0)
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))
      PHIY=ATAN(2.0*SY/D/E)
      EMY=E*SI*PHIY
      EM0S=EM0S*EMY
      PY=SA*SY
      PZ=PY
      PL=AL
      IF(IND.EQ.2.OR.IND.EQ.4) PL=2.0*AL
      IF(IND.EQ.5.OR.IND.EQ.6) PL=2.0*AL
      PAIL=PL/PAI
      PCR=E*SI/(PAIL*PAIL)
      PES=PCR/PY
      SRT=PL/SQRT(SI/SA)
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 20
      QS=QS*EMY*4.0/PL
      W0Q=QS*PL**3/(48.0*E*SI)
   20 IF(IND.EQ.5.OR.IND.EQ.6) QS=QS*PY
      W0M=EM0S*PL*PL/(8.0*E*SI)
      W0MQ=W0Q+W0M
      WYILD=PHIY*PAIL*PAIL
      DYILD=PL*SY/E
      DO 10 I=1,NEL+1
      DL=AL/FLOAT(NEL)
   10 X(I)=DL*FLOAT(I-1)
      WRITE(6,420) SI,SA,PHIY,PES,PY,EMY
      WRITE(6,430) W0MQ,SRT,WYILD,DYILD
      RETURN
  420 FORMAT(1H ,/,6X,'SI=',E12.4,'  SA=',E12.4,'  PHIY=',E12.4,'  PES='
     1     ,E12.4,'  PY=',E12.4,'  EMY=',E12.4)
  430 FORMAT(/,6X,  'W0QM=',E12.4,'    SRT=',E12.4,'    WYILD=',E12.4,
     1    '  DYILD=',E12.4)
      END
      SUBROUTINE PRBUCK(IND,IWQ,QR,AL,D,T,SY,E,PP,PDELT,NP,EM0S,QS,NEL,
     1        WL,PCR,     YA,P,YO,NQS)
C  NEWMARK'S METHOD FOR PREBUCKLING BRANCH
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION WL(20),YA(20),YO(20)
      PAI=4.0*ATAN(1.0)
      SI=PAI/64.0*(D**4-(D-2.0*T)**4)
      KW=1
      IF(NEL.GT.10) KW=2
      KP=0
      IRS=IWQ
      IF(IWQ.EQ.4.OR.IWQ.EQ.6) IRS=0
      IF(IWQ.EQ.5.OR.IWQ.EQ.7) IRS=1
      IF(IND.EQ.5.OR.IND.EQ.6) P=QS
C
      DO 100 IP=1,NP
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 20
      P=PP+PDELT*FLOAT(IP-1)
      WRITE(6,560) -P
      GO TO 30
   20 QS=PP+PDELT*FLOAT(IP-1)
      WRITE(6,580) QS
  580 FORMAT(1H ,/////,2X,'Q=',E13.4)
   30 PS=P/PY
      CALL MOMPHI(IRS,PS,QR)
      CALL ABCF
      PW=P
      IF(PW.GT.0.95*PCR) PW=0.95*PCR
      W0MQ=QS*(2.0*AL)**3/(48.0*E*SI)+EM0S*(2.0*AL)**2/(8.0*E*SI)
      WX=WL(NEL/2+1)+W0MQ
      IF(IND.EQ.2.OR.IND.GE.4) WX=WL(NEL+1)+W0MQ
      W1=WX/(1.0-PW/PCR)
      IF(W1.LT.1.0E-10) W1=0.1
      AROW=W1-WX
      IF(IND.EQ.5.OR.IND.EQ.6) AROW=W1
      DO 40 I=1,NEL+1
      YA(I)=AROW*SIN(PAI*X(I)/AL/2.0)
      IF(IND.EQ.1.OR.IND.EQ.3) YA(I)=AROW*SIN(PAI*X(I)/AL)
   40 IF(IND.EQ.7.OR.IND.EQ.8) YA(I)=0.5*AROW*(1.0-COS(PAI*X(I)/AL))
      WRITE(6,502) (X(I),I=1,NEL+1,KW)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
C  ITERATIVE PROCESS STARTS
      N=0
   90 N=N+1
      IF(N.LE.25) GO TO 80
      WRITE(6,900)
      GO TO 100
C
   80 CALL CYCLE(YA,   P,EM0S,QS,WL,NEL,IND,D,T,E,SY,IWQ,NQS,EMR)
      IF(D.GT.0.0) GO TO 50
      D=-D
      GO TO 850
C
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
   55 IF(ABS(YB(I)).GT.YAA) YAA=ABS(YB(I))
      IF(YAA.LT.0.001) GO TO 314
      EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.01*YAA) GO TO 350
  314 WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      KP=KP+1
      YY(KP)=-P
      IF(IND.EQ.5.OR.IND.EQ.6) YY(KP)=QS
      IF(IND.NE.1.AND.IND.NE.3) GO TO 10
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
      GO TO 100
   10 XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*YAA) GO TO 315
      WRITE(6,910)
      GO TO 850
  315 DO 320 I=1,NEL+1
      YO(I)=YA(I)
  320 YA(I)=YB(I)
      GO TO 90
  100 CONTINUE
  850 RETURN
  502 FORMAT(1H ,2X,'X(I)',3X,10E12.4)
  560 FORMAT(1H ,/////,2X,'P =',E13.4)
  561 FORMAT(1H ,/,5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(1H ,/,'==== CONVERGENCE')
  900 FORMAT(1H ,'***  TOO MANY ITERATIONS IN NEWMARK')
  910 FORMAT(1H ,/,'*** EROR GREATER THAN 50*YAA IN NEWMARK')
      END
      SUBROUTINE PSBUCK(YO,P,IWQ,QR,NEL,EM0S,QS,WL,IND,D,T,E,SY,AL,YLMT,
     1            NQS,YA)
C  NEWMARK'S METHOD FOR POST-BUCKLING BRANCH
C  THIS SUBROUTINE IS PROGRAMMED ONLY FOR SYMMETRIC BEAM-COLUMN
      COMMON /DATA/ EMY,PY,X(20),PHIY
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION YO(20),WL(20),YA(20)
      DY=0.0
      KW=1
      IF(NEL.GT.10) KW=2
      IRS=IWQ
      IF(IWQ.EQ.4.OR.IWQ.EQ.6) IRS=0
      IF(IWQ.EQ.5.OR.IWQ.EQ.7) IRS=1
      WRITE(6,500)
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 20
      DO 10 I=1,NEL+1
   10 YA(I)=YO(I)
   20 J=0
  100 J=J+1
      IF(J.LE.15) GO TO 104
      WRITE(6,910)
      GO TO 850
  104 M=0
      PUP=2.0*P
      PLO=0.0
      QUP=2.0*QS
      QLO=0.0
  105 M=M+1
      IF(M.LE.16) GO TO 110
      WRITE(6,905)
      GO TO 850
  110 N=0
   90 N=N+1
      IF(N.LE.15) GO TO 80
      WRITE(6,900)
      GO TO 850
   80 CONTINUE
      IF(IND.NE.5.AND.IND.NE.6) WRITE(6,560) -P
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      IF(IND.EQ.5.OR.IND.EQ.6) WRITE(6,580) QS
      PS=P/PY
C
      CALL MOMPHI(IRS,PS,QR)
      CALL ABCF
      CALL CYCLE(YA,   P,EM0S,QS,WL,NEL,IND,D,T,E,SY,IWQ,NQS,EMR)
C
      IF(D.GT.0.0) GO TO 50
      WRITE(6,501)
      D=-D
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 40
      PO= P
      PPL=(EMPC*EMY-EM0S+EMR-QS/2.0*X(NEL+1))/(YA(NEL+1)+WL(NEL+1))
      IF(PPL.LT.PO) P=(PPL+PO)/2.0
      IF(ABS(PO-P).LT.0.01) P=PO-0.5
      PUP=PO
      GO TO 105
   40 QO=QS
      QQL=(EMPC*EMY-EM0S+EMR-P*(YA(NEL+1)+WL(NEL+1)))*2.0/X(NQS)
      IF(QQL.GT.0.0) GO TO 45
      PRINT*,'   ***  QQL IS NEGATIVE'
      GO TO 850
   45 IF(QQL.LT.QO) QO=QQL
       QUP=QO
      QS=(QUP+QLO)/2.0
      GO TO 105
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
      IF(ABS(YB(I)).LT.YAA)  GO TO 55
      YAA=ABS(YB(I))
      IMAX=I
   55 CONTINUE
      IF(YAA.LT.0.01 *YA(NEL+1).OR.YAA.LT.0.01 ) GO TO 314
      EROR=0.01*YAA
      IC=0
      DO 310 I=1,NEL+1
  310 IF(ABS(YB(I)-YA(I)).GT.EROR) IC=I
      IF(IC.NE.0) GO TO 311
  314 IF(IND.EQ.5.OR.IND.EQ.6) WRITE(6,580) QS
      IF(IND.NE.5.AND.IND.NE.6) WRITE(6,560) -P
  580 FORMAT(/,4X,'QS=',E12.4)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      DY=DY+FLOAT(J)/2.0
      IF(DY.GT.1.5) DY=1.5
      IF(YB(NEL+1)+DY.GT.YLMT) DY=YLMT-YB(NEL+1)
      KP=KP+1
      YY(KP)=-P
      IF(IND.EQ.5.OR.IND.EQ.6) YY(KP)=QS
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      IF(DY.LT.0.3) GO TO 850
      DO 320 I=1,NEL+1
      IF(YB(I).GT.YLMT) GO TO 850
  320 YA(I)=YB(I)+DY*X(I)/AL
      GO TO 100
  311 IF(IC.EQ.NEL+1) GO TO 350
      DO 312 I=1,NEL+1
  312 YA(I)=YB(I)
      PUP=PUP+0.5
      PLO=PLO-0.5
      QUP=QUP+0.5
      QLO=QLO-0.5
      GO TO 105
  350 YMAX=YB(IMAX)
      IF(IND.EQ.5.OR.IND.EQ.6)  GO TO 360
      IF(N.NE.1) GO TO 351
      P1=(BM(IMAX)-EM0S+EMR-0.5*QS*X(IMAX))/(YMAX+WL(IMAX))
      IF(YB(IMAX).GT.YA(IMAX).AND.P1.GT.PLO) PLO=P1
      IF(YB(IMAX).LE.YA(IMAX).AND.P1.LT.PUP) PUP=P1
  351 IF(YB(IMAX).GT.YA(IMAX)) PUP=P
      IF(YB(IMAX).LE.YA(IMAX)) PLO=P
      P=(PUP+PLO)/2.0
      GO TO 90
  360 IF(N.NE.1) GO TO 361
      Q1=(BM(IMAX)-EM0S+EMR-P*(YMAX+WL(IMAX)))*2.0/X(NQS)
      IF(YB(IMAX).GT.YA(IMAX).AND.Q1.LT.QUP) QUP=Q1
       IF(YB(IMAX).LE.YA(IMAX).AND.Q1.GT.QLO) QLO=Q1
  361 IF(YB(IMAX).GT.YA(IMAX)) QUP=QS
      IF(YB(IMAX).LE.YA(IMAX)) QLO=QS
      QS=(QUP+QLO)/2.0
      GO TO 90
  850 RETURN
  500 FORMAT(/////,' --- POST-BUCKLING ---')
  501 FORMAT(6X,'CALLED IN PSBUCK')
  560 FORMAT(/,4X,'P =',E12.4)
  561 FORMAT(  5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(/,'  +++ CONVERGENCE',/////)
  900 FORMAT('  ***  TOO MANY ITERATIONS IN PSBUCK')
  905 FORMAT('  ***  M IS LARGER THAN 16')
  910 FORMAT('  ***  J IS LARGER THAN 15')
      END
      SUBROUTINE UNLOAD(IND,IWQ,QR,D,T,SY,E,PDELT,EM0S,QS,NEL,WL,PHIS,
     1      BMS,EIS,PIS,NQS,P)
C  NEWMARK'S METHOD FOR ELASTIC UNLOADING AND TENSIONING BRANCHES
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION YA(20),WL(20),BMS(20),PHIS(20),EIS(20)
      KW=1
      IF(NEL.GT.10) KW=2
      DO 15 I=1,NEL+1
      BMS(I)=BM(I)/EMY
      PHIS(I)=-PHI(I)/PHIY
      EIS(I)=E0(I)
   15 YA(I)=YB(I)
      PIS=YY(KP)
      WRITE(6,400)
      WRITE(6,502) (X(I),I=1,NEL+1,KW)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
C
      DO 100 IP=1,50
      IF(IND.EQ.5.OR.IND.EQ.6) GO TO 76
      P=0.98*PIS+PDELT*FLOAT(IP-1)
      IF(P.LT.PY) GO TO 75
      PRINT*,'  P IS GREATER THAN PY'
      GO TO 850
   75 WRITE(6,560) P
       GO TO 77
   76 QS=0.98*PIS-PDELT*FLOAT(IP-1)
      WRITE(6,580) QS
  580 FORMAT(1H ,/////,2X,'QS=',E13.4)
C  ITERATIVE PROCESS STARTS
   77 N=0
   90 N=N+1
      IF(N.LE.25) GO TO 80
      WRITE(6,900)
      GO TO 100
C
   80 CALL UNCYCL(YA,P,EM0S,QS,WL,NEL,IND,D,T,E,SY,BMS,PHIS,IWQ,QR,PS,
     1    EIS,PIS,NQS)
      IF(PS.LT.0.0) GO TO 850
C
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
   55 IF(ABS(YB(I)).GT.YAA) YAA=ABS(YB(I))
      IF(YAA.LT.0.001) GO TO 314
      EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.01*YAA) GO TO 350
  314 WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      KP=KP+1
      YY(KP)= P
      IF(IND.EQ.5.OR.IND.EQ.6) YY(KP)=QS
      IF(IND.NE.1.AND.IND.NE.3) GO TO 10
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
      GO TO 100
   10 XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*YAA) GO TO 315
      WRITE(6,910)
      GO TO 850
  315 DO 320 I=1,NEL+1
  320 YA(I)=YB(I)
      GO TO 90
  100 CONTINUE
  850 RETURN
  400 FORMAT(/////,'  --- ELASTIC UNLOADING AND TENSIONING ---')
  502 FORMAT(1H ,2X,'X(I)',3X,10E12.4)
  560 FORMAT(1H ,/////,2X,'P =',E13.4)
  561 FORMAT(1H ,/,5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(1H ,/,'==== CONVERGENCE')
  900 FORMAT(1H ,'***  TOO MANY ITERATIONS IN NEWMARK')
  910 FORMAT(1H ,/,'*** EROR GREATER THAN 50*YAA IN NEWMARK')
      END
      SUBROUTINE TENSPL(IND,IWQ,QR,D,T,SY,E,EM0,Q,NEL,WL,PHIS,BMS,
     1     EIS,PIS,NQS)
C  TENSION INCREASING BRANCH IN PLASTIC RANGE
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      COMMON /DATA/ EMY,PY,X(20),PHIY
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1         SLOPE0(20),YB(20),BM(20)
      DIMENSION  YA(20),WL(20),PHIS(20),BMS(20),EIS(20)
      WRITE(6,500)
      EMR=0.0
C   WHEN IWQ=6 OR 7, ANALYSIS IS NOT APPLICABLE TO FIXED-ENDS
C
      IF(IWQ.NE.6.AND.IWQ.NE.7) GO TO 40
      PAI=4.0*ATAN(1.0)
      R=(D-T)/2.0
      DPI=0.99*(PY-YY(KP))/5.0
      DO 30 I=1,5
      P=YY(KP)  +DPI
      IF(P.GT.PY) GO TO 850
      PS=P/PY
      EMPC=1.299*(1.0-1.18*PS*PS)
      IF(PS.GT.0.65) EMPC=1.86*(1.0-PS)
      KP=KP+1
      YY(KP)=P
      XW(KP)=(EMPC*EMY-EM0-0.5*Q *X(NEL+1))/P-WL(NEL+1)
      XS(KP)=P*X(NEL+1)/(PAI*E*T*R)-(COS(WL(NEL+1)/X(NEL+1))-COS((WL(NEL
     1      +1)+XW(KP))/X(NEL+1)))*X(NEL+1)*2.0
      PRINT*,'     P, XW, XS =',P,XW(KP),XS(KP)
   30 CONTINUE
      GO TO 850
C
   40 M=0
      IF(IND.NE.7.AND.IND.NE.8) GO TO 44
      YPHI=2.0*(YB(2)*X(3)**3-YB(3)*X(2)**3)/((X(2)*X(3))**2*(X(3)-X(2))
     1    )
      YPHI=YPHI/PHIY
      IF(YPHI.LE.PHI1) EMR=A*YPHI
      IF(YPHI.GT.PHI1.AND.YPHI.LE.PHI2) EMR=B-C/SQRT(YPHI)
      IF(YPHI.GT.PHI2) EMR=EMPC-F/YPHI/YPHI
      EMR=EMR*EMY
   44 KW=1
      IF(NEL.GT.10) KW=2
      IRS=IWQ
      IF(IWQ.EQ.4.OR.IWQ.EQ.6) IRS=0
      IF(IWQ.EQ.5.OR.IWQ.EQ.7) IRS=1
      YC=XW(KP)-1.0
      DO 10 I=1,NEL+1
   10 YA(I)=YC*X(I)/X(NEL+1)
  110 P=YY(KP)
      IF(YA(NEL+1).LT.0.0) P=1.1*PY
      PLO=YY(KP)
      PUP=2.0*YY(KP)
C  REPEAT FOR DIFFERENT DEFLECTION
      IF(P.LT.PY) GO TO 105
  115 P=PY*0.98
      PS=0.98
      CALL MOMPHI(IRS,PS,QR)
      CALL ABCF
      YC=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(0.98*PY)-WL(NEL+1)
      IF(ABS(YB(NEL+1)-0.1).LT.0.01) GO TO 12
      IF(YC.LT.0.0) YC=0.1
   12 DO 15 I=1,NEL+1
   15 YA(I)=(YC+WL(NEL+1))*X(I)/X(NEL+1)-WL(I)
C  ITERATION FOR CONVERGENCE
      M=0
  105 M=M+1
      IF(M.LE.25) GO TO 95
      WRITE(6,905)
      GO TO 850
   95 N=0
   90 N=N+1
      IF(N.LE.15) GO TO 80
      PRINT*,'  *** TOO MANY ITERATIONS IN TENSPL'
      GO TO 850
   80 CONTINUE
      WRITE(6,560) P
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      PS=ABS(P/PY)
C
      CALL UNCYCL(YA,P,EM0,Q,WL,NEL,IND,D,T,E,SY,BMS,PHIS,IWQ,QR,PS,
     1         EIS,PIS,NQS)
C
      IF(PS.GT.0.0) GO TO 50
      WRITE(6,601)
      IF(P.LT.PUP)  PUP=P
      IF(PUP-PLO.LT.1.0E-3) PLO=.999 *PLO
      P=(PUP+PLO)/2.0
      IF(P.GT.PY) GO TO 115
      PRINT*,'  PLO, PUP=',PLO,PUP
      GO TO 105
C  JUDGEMENT OF CONVERGENCE
   50 EROR=0.0
      DO 310 I=1,NEL+1
      DERR=YB(I)-YA(I)
  310 IF(ABS(DERR).GT.EROR) EROR=ABS(DERR)
      IF(EROR.GT.0.1 *YA(NEL+1).OR. PUP-PLO.GT.1.0) GO TO 350
      DO 311 I=1,NEL+1
  311 IF(ABS(YB(I)-YA(I)).GT.0.15*YA(I)) GO TO 350
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      KP=KP+1
      YY(KP)=P
      IF(IND.NE.1) GO TO 20
      XW(KP)=YB(NEL/2+1)
      XS(KP)=SLOPE0(NEL+1)
   20 IF(IND.NE.2) GO TO 100
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      GO TO 100
  350 IF(EROR.LT.50.0*ABS(YA(NEL+1)).OR.EROR.LT.50.0*ABS(YB(NEL+1)))
     1      GO TO 313
      WRITE(6,910)
      GO TO 850
  313 YAB=YA(NEL+1)*YB(NEL+1)
      IF(YAB.GT.0.0) GO TO 315
      PRINT*,'   ***  YB HAS OPPOSITE SIGN OF YA'
      IF(YB(NEL+1).LT.0.0) PUP=P
      IF(YB(NEL+1).GT.0.0) PLO=P
      P=(PUP+PLO)/2.0
      PRINT*,'                 PLO, PUP=',PLO,PUP
      IF(P.GT.PY) GO TO 115
      GO TO 105
  315 P1=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(YA(NEL+1)+WL(NEL+1))
      P2=(EMPC*EMY+EM0+0.5*Q*X(NEL+1)-EMR)/(YB(NEL+1)+WL(NEL+1))
      IF(YA(NEL+1).LT.YB(NEL+1)) GO TO 318
      PUP=P
      IF(P2.LT.PUP.AND.P2.GT.PLO) PUP=P2
      GO TO 319
  318 PLO=P
      IF(N.GT.1.OR.M.GT.1) GO TO 319
      IF(P1.LT.PUP.AND.P1.GT.PLO) PUP=P1
      IF(P2.GT.PLO.AND.P2.LT.PUP) PLO=P2
  319 P=(PLO+PUP)/2.0
      IF(P.GT.PY) GO TO 115
      PRINT*,'  PLO, PUP=',PLO,PUP
      IF(EROR.GT.10.0*ABS(YA(NEL+1))) GO TO 90
      DO 320 I=1,NEL+1
      YAI=(YB(I)+WL(I))*(YA(NEL+1)+WL(NEL+1))/(YB(NEL+1)+WL(NEL+1))-
     1      WL(I)
      IF(YB(NEL+1).LT.YA(NEL+1)) YAI=YB(I)-(YB(NEL+1)-YA(NEL+1))*X(I)/
     1     X(NEL+1)
  320 YA(I)=(YAI+YA(I))/2.0
      GO TO 90
  100 RA=ABS(P-PY)/PY
      IF(RA.LT.0.025) GO TO 850
      IF(YA(NEL+1)+WL(NEL+1).LT.0.05) GO TO 850
      DO 325 I=1,NEL+1
  325 YA(I)=YB(I)-    X(I)/X(NEL+1)
      GO TO 110
  850 RETURN
  500 FORMAT(/////,'  --- PLASTIC TENSIONING ---')
  560 FORMAT(/,4X,'P=',E12.4)
  561 FORMAT(5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/,1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(/,'  \\\ CONVERGENCE',/////)
  601 FORMAT(30X,'CALLED IN TENSPL')
  905 FORMAT('  *** M IS GREATER THAN 25')
  910 FORMAT(1H ,/,'  *** EROR GREATER THAN 50*YA(NEL+1) IN TENSPL')
      END
      SUBROUTINE UPQSPL(P,IWQ,QR,NEL,EM0S,QS,WL,IND,D,T,E,SY,AL,YLMT,
     1     NQS,YA,PHIS,BMS,EIS,PIS)
C  UPWARD LATERAL LOAD IN PLASTIC RANGE, IND=5 OR 6
C  THIS SUBROUTINE IS PROGRAMMED ONLY FOR SYMMETRIC BEAM-COLUMN
      COMMON /DATA/ EMY,PY,X(20),PHIY
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      COMMON /BPLOT/ KP,YY(150),XS(150),XW(150)
      DIMENSION WL(20),YA(20),PHIS(20),BMS(20),EIS(20)
      EMR=0.0
      DY=0.0
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,500)
      IF(IWQ.NE.6.AND.IWQ.NE.7) GO TO 20
      PAI=4.0*ATAN(1.0)
      R=(D-T)/2.0
      DO 30 I=1,10
      QS=YY(KP)-1.0
      KP=KP+1
      YY(KP)=QS
      XW(KP)=(EMPC*EMY-EM0S+0.5*QS*X(NEL+1))/P+WL(NEL+1)
      XS(KP)=P*X(NEL+1)/(PAI*E*T*R)-(COS(WL(NEL+1)/X(NEL+1))-COS((WL(NEL
     1     +1)+XW(KP))/X(NEL+1)))*X(NEL+1)*2.0
      PRINT*,'    Q,XW,XS =',QS,XW(KP),XS(KP)
   30 IF(ABS(XW(KP)).GT.YLMT) GO TO 850
      GO TO 850
   20 DO 10 I=1,NEL+1
   10 YA(I)=YB(I)*1.05
      J=0
  100 J=J+1
      IF(J.LE.15) GO TO 104
      WRITE(6,910)
      GO TO 850
  104 M=0
      QUP=2.0*QS
      QLO=0.0
  105 M=M+1
      IF(M.LE.16) GO TO 110
      WRITE(6,905)
      GO TO 850
  110 N=0
   90 N=N+1
      IF(N.LE.15) GO TO 80
      WRITE(6,900)
      GO TO 850
   80 CONTINUE
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      WRITE(6,580) QS
      PS=ABS(P/PY)
      CALL UNCYCL(YA,P,EM0S,QS,WL,NEL,IND,D,T,E,SY,BMS,PHIS,IWQ,QR,PS,
     1       EIS,PIS,NQS)
      IF(PS.GT.0.0) GO TO 50
      WRITE(6,501)
      QO=QS
      V=P
      IF(YA(NEL+1)+WL(NEL+1).GT.0.0) V=-P
      QQL=-(EMPC*EMY-EM0S+EMR+V*(YA(NEL+1)+WL(NEL+1)))*2.0/X(NQS)
      IF(QQL.LT.0.0) GO TO 45
      PRINT*,'   ***  QQL IS POSITIVE'
      GO TO 850
   45 IF(QQL.GT.QO) QO=QQL
       QUP=QO
      QS=(QUP+QLO)/2.0
      GO TO 105
C  JUDGEMENT FOR CONVERGENCE
   50 YAA=0.0
      DO 55 I=1,NEL+1
      IF(ABS(YB(I)).LT.YAA)  GO TO 55
      YAA=ABS(YB(I))
      IMAX=I
   55 CONTINUE
      EROR=0.05*YAA
      IC=0
      DO 310 I=1,NEL+1
  310 IF(ABS(YB(I)-YA(I)).GT.EROR) IC=I
      IF(IC.NE.0) GO TO 311
      WRITE(6,580) QS
  580 FORMAT(/,4X,'QS=',E12.4)
      WRITE(6,561) (YA(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
      WRITE(6,600)
      DY=DY+FLOAT(J)/2.0
      IF(DY.GT.1.5) DY=1.5
      IF(ABS(YB(NEL+1))+DY.GT.YLMT) DY=YLMT-ABS(YB(NEL+1))
      KP=KP+1
      YY(KP)=QS
      XW(KP)=YB(NEL+1)
      XS(KP)=SLOPE0(NEL+1)*2.0
      DO 320 I=1,NEL+1
      IF(ABS(YB(I)).GT.YLMT) GO TO 850
      YA(I)=YB(I)-DY*X(I)/AL
  320 IF(ABS(YA(I)).GT.YLMT-0.1) GO TO 850
      GO TO 100
  311 IF(IC.EQ.NEL+1) GO TO 350
      DO 312 I=1,NEL+1
  312 YA(I)=YB(I)
      QUP=QUP+0.5
      QLO=QLO-0.5
      GO TO 105
  350 YMAX=YB(IMAX)
      IF(N.NE.1) GO TO 361
      V=P
      IF(YA(NEL+1)+WL(NEL+1).GT.0.0) V=-P
      Q1=(BM(IMAX)-EM0S+EMR+V*(YMAX+WL(IMAX)))*2.0/X(NQS)
      IF(YB(IMAX).LT.YA(IMAX).AND.Q1.GT.QUP) QUP=Q1
       IF(YB(IMAX).GE.YA(IMAX).AND.Q1.LT.QLO) QLO=Q1
  361 IF(YB(IMAX).LT.YA(IMAX)) QUP=QS
      IF(YB(IMAX).GE.YA(IMAX)) QLO=QS
      QS=(QUP+QLO)/2.0
      GO TO 90
  850 RETURN
  500 FORMAT(/////,' ---  UPWARD QS IN PLASTIC RANGE',//)
  501 FORMAT(6X,'CALLED IN UPQSPL')
  561 FORMAT(  5X,'YA',3X,10E12.4)
  563 FORMAT(1H ,10X,100('*'),/,5X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
  600 FORMAT(/,'  +++ CONVERGENCE',/////)
  900 FORMAT('  ***  TOO MANY ITERATIONS IN UPQSPL')
  905 FORMAT('  ***  M IS LARGER THAN 16')
  910 FORMAT('  ***  J IS LARGER THAN 15')
      END
      SUBROUTINE CYCLE(YA,   P,EM0,Q,WL,NEL,IND,D,T,E,SY,IWQ,NQS,EMR)
C  CALCULATION OF 1-CYCLE OF ITERATION FOR NEWMARK'S METHOD
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      DIMENSION YA(20),WL(20)
      EMR=0.0
      IF(IND.NE.7.AND.IND.NE.8) GO TO 40
      YPHI=2.0*(YA(2)*X(3)**3-YA(3)*X(2)**3)/((X(2)*X(3))**2*(X(3)-X(2))
     1    )
      IF(YPHI.LE.PHI1) EMR=A*YPHI
      IF(YPHI.GT.PHI1.AND.YPHI.LE.PHI2) EMR=B-C/SQRT(YPHI)
      IF(YPHI.GT.PHI2) EMR=EMPC-F/YPHI/YPHI
      EMR=EMR*EMY
   40 DL=X(2)
      DO 110 I=1,NEL+1
      BM(I)=EM0-EMR+0.5*Q*X(I)+P*(YA(I)+WL(I))
  110 IF(I.GT.NQS) BM(I)=EM0-EMR+P*(YA(I)+WL(I))+0.5*Q*X(NQS)
      KW=1
      IF(NEL.GT.10) KW=2
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      DO 120 I=1,NEL+1
      EM=BM(I)/EMY
      IF(ABS(EM).LE.EM1) PHI(I)=EM
      IF(ABS(EM).GT.EM1.AND.ABS(EM).LE.EM2) PHI(I)=(C/(B-EM))**2
      IF(EMPC-EM.GT.0.0) GO TO 10
      WRITE(6,900)
      D=-D
      GO TO 850
   10 IF(ABS(EM).GT.EM2) PHI(I)=SQRT(F/(EMPC-EM))
      PHI(I)=-PHI(I)*PHIY
      IF(IWQ.LE.5) GO TO 4
      PAI=4.0*ATAN(1.0)
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))
      E0(I)=-P/E/SA
      GO TO 120
    4 PHIX=0.0
      PHY =PHI(I)
      CALL E0STRN(E,SY,D,T,-P,PHIX,PHY,E0(I),I)
  120 CONTINUE
*     WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
*     WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      ALPH(1)=DL/24.0*(7.0*PHI(1)+6.0*PHI(2)-PHI(3))
      ALPHE(1)=DL/24.0*(7.0*E0(1)+6.0*E0(2)-E0(3))
      DO 130 I=2,NEL
      ALPH(I)=DL/12.0*(PHI(I-1)+10.0*PHI(I)+PHI(I+1))
  130 ALPHE(I)=DL/12.0*(E0(I-1)+10.0*E0(I)+E0(I+1))
      ALPH(NEL+1)=DL/24.0*(7.0*PHI(NEL+1)+6.0*PHI(NEL)-PHI(NEL-1))
      ALPHE(NEL+1)=DL/24.0*(7.0*E0(NEL+1)+6.0*E0(NEL)-E0(NEL-1))
      IF(IND.NE.2. AND.IND.LE.3) GO TO 20
      ALPH(NEL+1)=DL/12.0*(2.0*PHI(NEL)+10.0*PHI(NEL+1))
      ALPHE(NEL+1)=DL/12.0*(2.0*E0(NEL)+10.0*E0(NEL+1))
   20 CONTINUE
*     WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
*     WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
C  SLOPE FOR ASYMMETRY COLUMN
      IF(IND.EQ.2.OR.IND.GE.4) GO TO 200
      ATOT=0.0
      DO 30 I=1,NEL+1
   30 ATOT=ATOT-ALPH(I)
      SLOPE(1)=ATOT/2.0
      DO 140 I=2,NEL
  140 SLOPE(I)=SLOPE(I-1)+ALPH(I)
      GO TO 210
C  SLOPE FOR SYMMETRY COLUMN
  200 SLOPE(NEL)=-ALPH(NEL+1)/2.0
      DO 220 I=1,NEL-1
      L=NEL-I
  220 SLOPE(L)=SLOPE(L+1)-ALPH(L+1)
  210 CONTINUE
*     WRITE(6,569) (SLOPE(I),I=1,NEL,KW)
      YB(1)=0.0
      DO 230 I=2,NEL+1
  230 YB(I)=YB(I-1)+SLOPE(I-1)*DL
      IF(IND.EQ.2.OR.IND.GE.4) GO TO 300
      DY=YB(NEL+1)/FLOAT(NEL)
      DO 50 I=1,NEL
   50 YB(I+1)=YB(I+1)-DY*FLOAT(I)
  300 CONTINUE
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
      SLOPE0(1)=0.0
      ALPHE(1)=2.0*ALPHE(1)
      IF(IND.EQ.1.OR.IND.EQ.3) ALPHE(NEL+1)=2.0*ALPHE(NEL+1)
      DO 145 I=2,NEL+1
      DL2=(YB(I-1)-YB(I))**2
      DELTA=DL-SQRT(DL*DL-DL2)
  145 SLOPE0(I)=SLOPE0(I-1)+(ALPHE(I-1)+ALPHE(I))/2.0-DELTA
*     WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
  850 RETURN
  563 FORMAT(1H ,4X,'BM',3X,10E12.4)
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
  900 FORMAT('  *** EM GREATER THAN EMPC')
      END
      SUBROUTINE UNCYCL(YA,P,EM0,Q,WL,NEL,IND,D,T,E,SY,BMS,PHIS,IWQ,QR,
     1     PS,EIS,PIS,NQS)
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      COMMON  /DATA/  EMY,PY,X(20),PHIY
      COMMON /ITERAT/ PHI(20),E0(20),ALPH(20),ALPHE(20),SLOPE(20),
     1       SLOPE0(20),YB(20),BM(20)
      DIMENSION YA(20),WL(20),BMS(20),PHIS(20),EIS(20)
      EMR=0.0
      IF(IND.NE.5.AND.IND.NE.6) GO TO 10
      P=-ABS(P)
   10 IF(IND.NE.7.AND.IND.NE.8) GO TO 40
      YPHI=2.0*(YA(2)*X(3)**3-YA(3)*X(2)**3)/((X(2)*X(3))**2*(X(3)-X(2))
     1    )
      YPHI=YPHI/PHIY
      IF(YPHI.LE.PHI1) EMR=A*YPHI
      IF(YPHI.GT.PHI1.AND.YPHI.LE.PHI2) EMR=B-C/SQRT(YPHI)
      IF(YPHI.GT.PHI2) EMR=EMPC-F/YPHI/YPHI
      EMR=EMR*EMY
   40 DL=X(2)
      KW=1
      IF(NEL.GT.10) KW=2
      PS=ABS(P/PY)
      DO 110 I=1,NEL+1
      BM(I)=EM0-EMR+0.5*Q*X(I)-P*(YA(I)+WL(I))
  110 IF(I.GT.NQS) BM(I)=EM0-EMR-P*(YA(I)+WL(I))+0.5*Q*X(NQS)
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      DO 120 I=1,NEL+1
      BMI=BM(I)/EMY
C
      CALL MOMREV(IWQ,PS,QR,PHIS(I),BMS(I),BMI,  PHI(I))
C
      IF(PS.LT.0.0) GO TO 850
      PHI(I)=-PHI(I)*PHIY
C  AXIAL STRAIN
C    ELASTIC AXIAL STRAIN
      PAI=4.0*ATAN(1.0)
      SA=PAI/4.0*(D*D-(D-2.0*T)*(D-2.0*T))
      IF(IWQ.LE.5) GO TO 4
      E0(I)=P/E/SA
      GO TO 120
C    SYMMETRIC CURVES FOR P-M-E0
    4 IF(P.GT.0.0) GO TO 5
      E0(I)=EIS(I)-(PIS-P)/E/SA
      GO TO 120
    5 EM=ABS(BMI)
      IF(EM.LE.EM1) PHIE=EM
      IF(EM.GT.EM1.AND.EM.LE.EM2) PHIE=(C/(B-EM))**2
      IF(EM.GT.EM2) PHIE=SQRT(F/(EMPC-EM))
      PHY=-PHIE*PHIY
      PHIX=0.0
      CALL E0STRN(E,SY,D,T,-P,PHIX,PHY,E2,I)
      E0(I)=EIS(I)-PIS/E/SA-E2
  120 CONTINUE
C
*     WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
*     WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      ALPH(1)=DL/24.0*(7.0*PHI(1)+6.0*PHI(2)-PHI(3))
      ALPHE(1)=DL/24.0*(7.0*E0(1)+6.0*E0(2)-E0(3))
      DO 130 I=2,NEL
      ALPH(I)=DL/12.0*(PHI(I-1)+10.0*PHI(I)+PHI(I+1))
  130 ALPHE(I)=DL/12.0*(E0(I-1)+10.0*E0(I)+E0(I+1))
      ALPH(NEL+1)=DL/24.0*(7.0*PHI(NEL+1)+6.0*PHI(NEL)-PHI(NEL-1))
      ALPHE(NEL+1)=DL/24.0*(7.0*E0(NEL+1)+6.0*E0(NEL)-E0(NEL-1))
      IF(IND.NE.2.AND.IND.LE.3) GO TO 20
      ALPH(NEL+1)=DL/12.0*(2.0*PHI(NEL)+10.0*PHI(NEL+1))
      ALPHE(NEL+1)=DL/12.0*(2.0*E0(NEL)+10.0*E0(NEL+1))
   20 CONTINUE
*     WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
*     WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
C  SLOPE FOR ASYMMETRY COLUMN
      IF(IND.EQ.2.OR.IND.GE.4) GO TO 200
      ATOT=0.0
      DO 30 I=1,NEL+1
   30 ATOT=ATOT-ALPH(I)
      SLOPE(1)=ATOT/2.0
      DO 140 I=2,NEL
  140 SLOPE(I)=SLOPE(I-1)+ALPH(I)
      GO TO 210
C  SLOPE FOR SYMMETRY COLUMN
  200 SLOPE(NEL)=-ALPH(NEL+1)/2.0
      DO 220 I=1,NEL-1
      L=NEL-I
  220 SLOPE(L)=SLOPE(L+1)-ALPH(L+1)
  210 CONTINUE
*     WRITE(6,569) (SLOPE(I),I=1,NEL,KW)
      YB(1)=0.0
      DO 230 I=2,NEL+1
  230 YB(I)=YB(I-1)+SLOPE(I-1)*DL
      IF(IND.EQ.2.OR.IND.GE.4) GO TO 300
      DY=YB(NEL+1)/FLOAT(NEL)
      DO 50 I=1,NEL
   50 YB(I+1)=YB(I+1)-DY*FLOAT(I)
  300 WRITE(6,571) (YB(I),I=1,NEL+1,KW)
****
      IF(P.LT.43.0) GO TO 123
      WRITE(6,563) (BM(I),I=1,NEL+1,KW)
      WRITE(6,565) (PHI(I),I=1,NEL+1,KW)
      WRITE(6,566) (E0(I),I=1,NEL+1,KW)
      WRITE(6,567) (ALPH(I),I=1,NEL+1,KW)
      WRITE(6,568) (ALPHE(I),I=1,NEL+1,KW)
      WRITE(6,569) (SLOPE(I),I=1,NEL+1,KW)
      WRITE(6,571) (YB(I),I=1,NEL+1,KW)
  123 CONTINUE
****
      SLOPE0(1)=0.0
      ALPHE(1)=2.0*ALPHE(1)
      IF(IND.EQ.1.OR.IND.EQ.3) ALPHE(NEL+1)=2.0*ALPHE(NEL+1)
      DO 145 I=2,NEL+1
      DL2=(YB(I-1)-YB(I))**2
      IF(SQRT(DL2).GT.DL) DL2=DL*DL
      DELTA=DL-SQRT(DL*DL-DL2)
  145 SLOPE0(I)=SLOPE0(I-1)+(ALPHE(I-1)+ALPHE(I))/2.0-DELTA
*     WRITE(6,573) (SLOPE0(I),I=1,NEL+1,KW)
  850 RETURN
  563 FORMAT(1H ,4X,'BM',3X,10E12.4)
  565 FORMAT(4X,'PHI',3X,10E12.4)
  566 FORMAT(4X,'E0',4X,10E12.4)
  567 FORMAT(3X,'ALPH',3X,10E12.4)
  568 FORMAT(1H ,'ALPHE0',3X,10E12.4)
  569 FORMAT(2X,'SLOPE',9X,9E12.4)
  571 FORMAT(1H ,  4X,'YB',3X,10E12.4)
  573 FORMAT(1H ,/, 1X,'SLOPE0',3X,10E12.4)
      END
      SUBROUTINE MOMREV(IWQ,PS,QR,PHIS,EMS,EM,PHI)
C  M-P-PHI FOR CYCLIC LOADING
C   IWQ=0 TO 3 ... DOUBLED SYMMETRIC CURVE
C   IWQ=4,5 ... SYMMETRIC CURVE
C   IWQ=6,7 ... STRAIGHT LINE SIMPLIFICATION
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
      DIMENSION X(3),XM(3)
      IRS=IWQ
      IF(IWQ.EQ.4.OR.IWQ.EQ.6) IRS=0
      IF(IWQ.EQ.5.OR.IWQ.EQ.7) IRS=1
      CALL MOMPHI(IRS,PS,QR)
      CALL ABCF
      IF(EM.GT.-EMPC) GO TO 100
      WRITE(6,900)
      PS=-PS
      GO TO 850
C  ELASTIC BEHAVIOR
  100 IF(ABS(EMS-A*PHIS).GT.1.0E-10) GO TO 200
      IF(EM.LT.EMS.AND.EM.GE.-EM1) PHI=EM/A
      IF(EM.LT.-EM1.AND.EM.GE.-EM2) PHI=-(C/(EM+B))**2
      IF(EM.LT.-EM2) PHI=-SQRT(F/(EM+EMPC))
      GO TO 850
C  OBTAIN THE ORIGIN FOR NEW CURVE IN PRIMARY YIELDED ZONE
  200 Q1=A
      Q2=0.0
      Q3=EMS-A*PHIS-B
      Q4=C
      CALL ROTCUB(Q1,Q2,Q3,Q4,X1,X2,X3)
      X(1)=X1*X1
      X(2)=X2*X2
      X(3)=X3*X3
      DO 20 J=1,3
      XM(J)=A*(X(J)-PHIS)+EMS
   20 IF(X(J).GE.PHI1.AND.X(J).LE.PHI2.AND.XM(J).GE.EM1.AND.XM(J).LE.EM2
     1     )  GO TO 30
      GO TO 300
   30 PHI0=X(J)
      EM0=XM(J)
      IF(IWQ.GE.4) GO TO 60
      AM1=-2.0*EM1+EM0
      IF(EM.LE.EM0.AND.EM.GT.AM1) PHI=(EM+A*PHI0-EM0)/A
      IF(EM.LE.AM1.AND.EM.GT.-EM0) PHI=PHI0-(2.828427*C/(EM-EM0+2.0*B))
     1      **2
      IF(EM.LE.-EM0.AND.EM.GT.-EM2) PHI=-(C/(EM+B))**2
      IF(EM.LE.-EM2) PHI=-SQRT(F/(EM+EMPC))
      GO TO 850
C
C  OBTAIN THE ORIGIN FOR NEW CURVE IN SECONDARY YIELDED ZONE
  300 Q1=A
      Q2=EMS-A*PHIS-EMPC
      Q3=0.0
      Q4=F
      CALL ROTCUB(Q1,Q2,Q3,Q4,X(1),X(2),X(3))
      DO 40 J=1,3
      XM(J)=A*(X(J)-PHIS)+EMS
   40 IF(X(J).GE.PHI2.AND.XM(J).GE.EM2) GO TO 50
      PRINT*,'  NO INTERSECTION'
      STOP
   50 PHI0=X(J)
      EM0=XM(J)
      IF(IWQ.GE.4) GO TO 60
      AM1=-2.0*EM1+EM0
      AM2=-2.0*EM2+EM0
      IF(EM.LE.EM0.AND.EM.GT.AM1) PHI=(EM+A*PHI0-EM0)/A
      IF(EM.LE.AM1.AND.EM.GT.AM2) PHI=PHI0-(2.828427*C/(EM-EM0+2.0*B))**
     1          2
      IF(EM.LE.AM2.AND.EM.GT.-EM0) PHI=PHI0-SQRT(8.0*F/(EM-EM0+2.0*EMPC)
     1      )
      IF(EM.LE.-EM0) PHI=-SQRT(F/(EM+EMPC))
C
C  CURVATURE FOR SYMMETRIC UNLOADING CURVE OF M-P-PHI
   60 IF(IWQ.GE.6) GO TO 65
      IF(EM.LE.EM0.AND.EM.GT.-EM1) PHI=EM/A+PHI0-A*EM0
      IF(EM.LE.-EM1.AND.EM.GT.-EM2) PHI=-A*EM0-(C/(EM+B))**2+PHI0
      IF(EM.LE.-EM2) PHI=PHI0-A*EM0-SQRT(F/(EM+EMPC))
      IF(EM.LT.-EMPC) PRINT*,'  *** EM LESS THAN -EMPC IN SYMM CURVE'
      GO TO 850
C  CURVATURE FOR STRAIGHT UNLOADING LINES OF M-P-PHI
   65 IF(EM.LE.EM0.AND.EM.GT.-EMPC) PHI=EM/A+PHI0-A*EM0
      IF(EM.GT.-EMPC) GO TO 850
      PRINT*,'  *** EM LESS THAN -EMPC IN STRAIGHT LINES'
      PS=-PS
C
  850 RETURN
  900 FORMAT('  *** EM LESS THAN -EMPC')
      END
      SUBROUTINE CUBIC(A,XR,XI)
C   THIS SUBROUTINE IS USED IN 'ROTCUB'
      DIMENSION A(4),XR(3),AQ(3)
      INTEGER PATH
      PATH=2
      EX=1.0/3.0
      IF(A(4).NE.0.0) GO TO 300
      XR(1)=0.0
      GO TO 10
  300 A2=A(1)**2
      Q=(27.0*A2*A(4)-9.0*A(1)*A(2)*A(3)+2.0*A(2)**3)/(54.0*A2*A(1))
      IF(Q) 400,500,600
  500 Z=0.0
      GO TO 20
  400 Q=-Q
      PATH=1
  600 P=(3.0*A(1)*A(3)-A(2)**2)/(9.0*A2)
      ARG=P**3+Q**2
      IF(ARG) 700,800,900
  700 Z=-2.0*SQRT(-P)*COS(ATAN(SQRT(-ARG)/Q)/3.0)
      GO TO 30
  800 Z=-2.0*Q**EX
      GO TO 30
  900 SARG=SQRT(ARG)
      IF(P) 1000,1100,1200
 1000 Z=-(Q+SARG)**EX-(Q-SARG)**EX
      GO TO 30
 1100 Z=-(2.0*Q)**EX
      GO TO 30
 1200 Z=(SARG-Q)**EX-(SARG+Q)**EX
   30 GO TO (1300,20),PATH
 1300 Z=-Z
   20 XR(1)=(3.0*A(1)*Z-A(2))/(3.0*A(1))
   10 AQ(1)=A(1)
      AQ(2)=A(2)+XR(1)*A(1)
      AQ(3)=A(3)+XR(1)*AQ(2)
      CALL QUAD(AQ,XR(2),XR(3),XI)
      RETURN
      END
      SUBROUTINE  QUAD(A,XR1,XR2,XI)
C   THIS SUBROUTINE IS USED IN 'ROTCUB'
      DIMENSION A(3)
      X1=-A(2)/(2.0*A(1))
      D=X1**2-A(3)/A(1)
      IF(D.GE.0.0) GO TO 20
      X2=SQRT(-D)
      XR1=X1
      XR2=X1
      XI=X2
      GO TO 30
   20 X2=SQRT(D)
      XR1=X1+X2
      XR2=X1-X2
      XI=0.0
   30 RETURN
      END
      SUBROUTINE ROTCUB(A1,A2,A3,A4,X1,X2,X3)
C  GET 3-ROOTS SOLVING CUBIC EQUATION
      DIMENSION A(4),X(3),XI(3)
      A(1)=A1
      A(2)=A2
      A(3)=A3
      A(4)=A4
      IF(A(1).EQ.0.0) GO TO 5
      CALL CUBIC(A,X,XI(2))
      XI(1)=0.0
      XI(3)=-XI(2)
*     WRITE(6,20) A,X,XI
      X1=X(1)
      X2=X(2)
      X3=X(3)
      GO TO 100
    5 PRINT*,'  A(1) EQUALS TO 0.0 IN ROTCUB'
      STOP
   20 FORMAT(//,7X,4HA(1),13X,4HA(2),13X,4HA(3),13X,4HA(4),/
     1   4(2X,E15.7,1X),//,22X,8H2ND ROOT,9X,8H3RD ROOT,/,
     2   7X,9HREAL PART,3(3X,E15.7),/,17H   IMAGINARY PART,3(3X,E15.7))
  100 RETURN
      END
      SUBROUTINE E0STRN(E,SYILD,DIA,T,P,PHIX,PHIY,E01,J)
C  CALCULATION OF AXIAL STRAIN, E0, KNOWING P, PHIX AND PHIY
      RC=(DIA-T)/2.0
      N=0
      EY=SYILD/E
      PAI=4.0*ATAN(1.0)
      E0=P/(2.0*PAI*E*T*RC)
      IF(P.GT.0.0) E01=E0
      IF(P.GT.0.0) GO TO 100
      ERR=1.0E-5
      PHI0=SQRT(PHIX*PHIX+PHIY*PHIY)
      TPHI=RC*TAN(PHI0)
      EULT1=TPHI-E0
      EULT2=TPHI+E0
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300
      IF(EULT1.GT.EY. OR.EULT2.GT.EY) GO TO 200
      E01=E0
      GO TO 100
  200 N=N+1
      IF(N.GT.30) GO TO 190
      ETA1=(EY+E0)/TPHI
      IF(ABS(ETA1).GT.1.0) GO TO 191
      THETY=ASIN(ETA1)
      E01=(P/(E*T*RC)+EY*(PAI-2.0*THETY)-2.0*TPHI*COS(THETY))/(PAI+
     1     2.0*THETY)
      EULT1=TPHI-E01
      EULT2=TPHI+E01
      IF(EULT1.GT.EY.AND.EULT2.GT.EY) GO TO 300
      IF(ABS(E01-E0).LT.ERR) GO TO 100
      E0=E01
      GO TO 200
  300 N=N+1
      IF(N.GT.30) GO TO 190
      ETA1=(EY+E0)/TPHI
      ETA2=(EY-E0)/TPHI
      IF(ABS(ETA1).GT.1.0) GO TO 191
      IF(ABS(ETA2).GT.1.0) GO TO 200
      THETY1=ASIN(ETA1)
      THETY2=ASIN(ETA2)
      E01=(P/(2.0*E*T*RC)-TPHI*(COS(THETY1)-COS(THETY2))-EY*(THETY1-
     1     THETY2))/(THETY1+THETY2)
      IF(ABS(E01-E0).LT.ERR) GO TO 100
      E0=E01
      GO TO 300
  190 WRITE(6,519)  J,(E01-E0)
      GO TO 100
  191 WRITE(6,520) J
  100 RETURN
  519 FORMAT(1H ,   ' ***  TOO MANY ITERATIONS IN CACULATING E0',
     1      '  J=',I3,'  ERROR=',E12.4)
  520 FORMAT(1H ,   ' ***  ETA1.GT. 1  IN E0-STRAIN  J=',I3)
      END
      SUBROUTINE ABCF
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
C    COEFFICIENTS OF CIRCULAR TUBE SECTION FOR M-P-PHI
      A=EM1/PHI1
      F=(EMPC-EM2)*PHI2*PHI2
      IF(ABS(PHI1-PHI2).GT.1.0E-5) GO TO 10
      B=0.0
      C=0.0
      GO TO 20
   10 IF(PHI1.GT.1.0E-5.AND.EM1.GT.1.0E-5) GO TO 30
      B=0.0
      C=-EM2*SQRT(PHI2)
      GO TO 20
   30 B=(EM2*SQRT(PHI2)-EM1*SQRT(PHI1))/(SQRT(PHI2)-SQRT(PHI1))
      C=(EM2-EM1)/(1.0/SQRT(PHI1)-1.0/SQRT(PHI2))
   20 RETURN
      END
      SUBROUTINE MOMPHI(IRS,PS,QR)
C  IRS=0... WITHOUT RESIDUAL STRESS
C  IRS=1... WITH RESIDUAL STRESS
C  IRS=2... WITH HYDROSTATIC PRESSURE
C  IRS=3... SHERMAN'S TEST CURVE FITTING
      COMMON /ABC/  A,B,C,F,EM1,EM2,EMPC,PHI1,PHI2
C    CALCULATION OF M1,PHI1,M2,PHI2,MPC WHICH ARE THE BOUNDARY VALUES
C    FOR M-P-PHI EQUATIONS
C    * CIRCULAR TUBE SECTION
C  FIT THE CURVES TO SHERMAN'S TEST RESULTS
      IF(IRS.NE.3)  GO TO 30
      EM1=0.75-PS
      IF(EM1.LT.0.0) EM1=1.0E-10
      PHI1=EM1
      EM2=1.24-0.233*PS-1.17*PS*PS
      IF(PS.GT.0.6) EM2=1.7*(1.0-PS)
      PHI2=3.6-0.433*PS-0.25*PS*PS-2.917*PS**3
      GO TO 220
   30 CONTINUE
C  SALEEB'S CURVE FITTING EQUATIONS
      IF(IRS.NE.0)  GO TO 200
C   WITHOUT RESIDUAL STRESSES
      EM1=1.0-PS
      PHI1=EM1
      IF(PS.GT.0.4) GO TO 50
      EM2=1.0+0.21*PS-1.05*PS*PS
      PHI2=1.0/(1.0-1.395*PS+1.206*PS*PS)
      GO TO 220
   50 EM2=1.528*(1.0-PS)
      PHI2=2.625*(1.0-PS)
      GO TO 220
C   WITH RESIDUAL STRESSES
  200 IF(IRS.NE.1)  GO TO 300
      IF(PS.GT.0.6) GO TO 210
      EM1=0.893-1.305*PS+0.796*PS*PS
      PHI1=EM1
      EM2=0.893+0.546*PS-1.946*PS*PS
      PHI2=1.0/(1.12-2.491*PS+4.308*PS*PS)
      GO TO 220
  210 EM1=1.50-2.333*PS+0.833*PS*PS
      PHI1=EM1
      EM2=1.375-1.5*PS+0.125*PS*PS
      PHI2=1.0+0.875*PS-1.875*PS*PS
  220 IF(PS.GT.0.65) GO TO 230
      EMPC=1.299*(1.0-1.18*PS*PS)
      GO TO 240
  230 EMPC=1.86*(1.0-PS)
  300 IF(IRS.NE.2) GO TO 240
      IF(PS.GT.0.4) GO TO 40
      EM1=1.25*PS-2.5*(PS-0.4)*(0.893-0.876*QR+0.591*QR*QR)
      PHI1=1.25*PS-2.5*(PS-0.4)*(.893-0.876*QR+0.591*QR*QR)
      GO TO 42
   40 IF(PS.GT.0.6) GO TO 41
      EM1=0.893-1.305*PS+0.796*PS*PS
      PHI1=.893-1.305*PS+0.796*PS*PS
      GO TO 42
   41 EM1=1.5-2.333*PS+0.833*PS*PS
      PHI1=1.5-2.333*PS+0.833*PS*PS
   42 IF(PS.GT.0.4) GO TO 43
      EM2=2.5*PS*(0.8+0.066*QR-0.166*QR*QR)-2.5*(PS-0.4)*(0.893+QR-1.32
     1        *QR*QR)
      PHI2=2.5*PS*(1.26+0.053*QR-0.133*QR*QR)-2.5*(PS-0.4)*(0.893+1.925
     1    *QR-1.8*QR*QR)
      GO TO 47
   43 IF(PS.GT.0.6) GO TO 46
      EM2=0.893+0.546*PS-1.946*PS*PS
      PHI2=1.0/(1.12-2.491*PS+4.308*PS*PS)
      GO TO 47
   46 EM2=1.375-1.5*PS+0.125*PS*PS
      PHI2=1.0+0.875*PS-1.875*PS*PS
   47 EMPC=1.307*(1.0-1.12*PS*PS)*(1.0-0.2*QR)
      IF(PS.GT.0.65) EMPC=2.03*(1.0-PS)*(1.0-0.2*QR)
  240 RETURN
      END
